// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from microstrain_inertial_msgs:msg/FilterAidingMeasurementSummary.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_AIDING_MEASUREMENT_SUMMARY__BUILDER_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_AIDING_MEASUREMENT_SUMMARY__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "microstrain_inertial_msgs/msg/detail/filter_aiding_measurement_summary__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace microstrain_inertial_msgs
{

namespace msg
{

namespace builder
{

class Init_FilterAidingMeasurementSummary_speed
{
public:
  explicit Init_FilterAidingMeasurementSummary_speed(::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary & msg)
  : msg_(msg)
  {}
  ::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary speed(::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary::_speed_type arg)
  {
    msg_.speed = std::move(arg);
    return std::move(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary msg_;
};

class Init_FilterAidingMeasurementSummary_magnetometer
{
public:
  explicit Init_FilterAidingMeasurementSummary_magnetometer(::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary & msg)
  : msg_(msg)
  {}
  Init_FilterAidingMeasurementSummary_speed magnetometer(::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary::_magnetometer_type arg)
  {
    msg_.magnetometer = std::move(arg);
    return Init_FilterAidingMeasurementSummary_speed(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary msg_;
};

class Init_FilterAidingMeasurementSummary_pressure
{
public:
  explicit Init_FilterAidingMeasurementSummary_pressure(::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary & msg)
  : msg_(msg)
  {}
  Init_FilterAidingMeasurementSummary_magnetometer pressure(::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary::_pressure_type arg)
  {
    msg_.pressure = std::move(arg);
    return Init_FilterAidingMeasurementSummary_magnetometer(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary msg_;
};

class Init_FilterAidingMeasurementSummary_heading
{
public:
  explicit Init_FilterAidingMeasurementSummary_heading(::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary & msg)
  : msg_(msg)
  {}
  Init_FilterAidingMeasurementSummary_pressure heading(::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary::_heading_type arg)
  {
    msg_.heading = std::move(arg);
    return Init_FilterAidingMeasurementSummary_pressure(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary msg_;
};

class Init_FilterAidingMeasurementSummary_dual_antenna
{
public:
  explicit Init_FilterAidingMeasurementSummary_dual_antenna(::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary & msg)
  : msg_(msg)
  {}
  Init_FilterAidingMeasurementSummary_heading dual_antenna(::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary::_dual_antenna_type arg)
  {
    msg_.dual_antenna = std::move(arg);
    return Init_FilterAidingMeasurementSummary_heading(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary msg_;
};

class Init_FilterAidingMeasurementSummary_gnss2
{
public:
  explicit Init_FilterAidingMeasurementSummary_gnss2(::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary & msg)
  : msg_(msg)
  {}
  Init_FilterAidingMeasurementSummary_dual_antenna gnss2(::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary::_gnss2_type arg)
  {
    msg_.gnss2 = std::move(arg);
    return Init_FilterAidingMeasurementSummary_dual_antenna(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary msg_;
};

class Init_FilterAidingMeasurementSummary_gnss1
{
public:
  explicit Init_FilterAidingMeasurementSummary_gnss1(::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary & msg)
  : msg_(msg)
  {}
  Init_FilterAidingMeasurementSummary_gnss2 gnss1(::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary::_gnss1_type arg)
  {
    msg_.gnss1 = std::move(arg);
    return Init_FilterAidingMeasurementSummary_gnss2(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary msg_;
};

class Init_FilterAidingMeasurementSummary_gps_tow
{
public:
  Init_FilterAidingMeasurementSummary_gps_tow()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_FilterAidingMeasurementSummary_gnss1 gps_tow(::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary::_gps_tow_type arg)
  {
    msg_.gps_tow = std::move(arg);
    return Init_FilterAidingMeasurementSummary_gnss1(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary>()
{
  return microstrain_inertial_msgs::msg::builder::Init_FilterAidingMeasurementSummary_gps_tow();
}

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_AIDING_MEASUREMENT_SUMMARY__BUILDER_HPP_
