// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from microstrain_inertial_msgs:msg/FilterAidingMeasurementSummary.idl
// generated code does not contain a copyright notice
#include "microstrain_inertial_msgs/msg/detail/filter_aiding_measurement_summary__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `gnss1`
// Member `gnss2`
// Member `dual_antenna`
// Member `heading`
// Member `pressure`
// Member `magnetometer`
// Member `speed`
#include "microstrain_inertial_msgs/msg/detail/filter_aiding_measurement_summary_indicator__functions.h"

bool
microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__init(microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary * msg)
{
  if (!msg) {
    return false;
  }
  // gps_tow
  // gnss1
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__init(&msg->gnss1)) {
    microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__fini(msg);
    return false;
  }
  // gnss2
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__init(&msg->gnss2)) {
    microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__fini(msg);
    return false;
  }
  // dual_antenna
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__init(&msg->dual_antenna)) {
    microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__fini(msg);
    return false;
  }
  // heading
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__init(&msg->heading)) {
    microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__fini(msg);
    return false;
  }
  // pressure
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__init(&msg->pressure)) {
    microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__fini(msg);
    return false;
  }
  // magnetometer
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__init(&msg->magnetometer)) {
    microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__fini(msg);
    return false;
  }
  // speed
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__init(&msg->speed)) {
    microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__fini(msg);
    return false;
  }
  return true;
}

void
microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__fini(microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary * msg)
{
  if (!msg) {
    return;
  }
  // gps_tow
  // gnss1
  microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__fini(&msg->gnss1);
  // gnss2
  microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__fini(&msg->gnss2);
  // dual_antenna
  microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__fini(&msg->dual_antenna);
  // heading
  microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__fini(&msg->heading);
  // pressure
  microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__fini(&msg->pressure);
  // magnetometer
  microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__fini(&msg->magnetometer);
  // speed
  microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__fini(&msg->speed);
}

bool
microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__are_equal(const microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary * lhs, const microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // gps_tow
  if (lhs->gps_tow != rhs->gps_tow) {
    return false;
  }
  // gnss1
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__are_equal(
      &(lhs->gnss1), &(rhs->gnss1)))
  {
    return false;
  }
  // gnss2
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__are_equal(
      &(lhs->gnss2), &(rhs->gnss2)))
  {
    return false;
  }
  // dual_antenna
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__are_equal(
      &(lhs->dual_antenna), &(rhs->dual_antenna)))
  {
    return false;
  }
  // heading
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__are_equal(
      &(lhs->heading), &(rhs->heading)))
  {
    return false;
  }
  // pressure
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__are_equal(
      &(lhs->pressure), &(rhs->pressure)))
  {
    return false;
  }
  // magnetometer
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__are_equal(
      &(lhs->magnetometer), &(rhs->magnetometer)))
  {
    return false;
  }
  // speed
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__are_equal(
      &(lhs->speed), &(rhs->speed)))
  {
    return false;
  }
  return true;
}

bool
microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__copy(
  const microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary * input,
  microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary * output)
{
  if (!input || !output) {
    return false;
  }
  // gps_tow
  output->gps_tow = input->gps_tow;
  // gnss1
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__copy(
      &(input->gnss1), &(output->gnss1)))
  {
    return false;
  }
  // gnss2
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__copy(
      &(input->gnss2), &(output->gnss2)))
  {
    return false;
  }
  // dual_antenna
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__copy(
      &(input->dual_antenna), &(output->dual_antenna)))
  {
    return false;
  }
  // heading
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__copy(
      &(input->heading), &(output->heading)))
  {
    return false;
  }
  // pressure
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__copy(
      &(input->pressure), &(output->pressure)))
  {
    return false;
  }
  // magnetometer
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__copy(
      &(input->magnetometer), &(output->magnetometer)))
  {
    return false;
  }
  // speed
  if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummaryIndicator__copy(
      &(input->speed), &(output->speed)))
  {
    return false;
  }
  return true;
}

microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary *
microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary * msg = (microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary));
  bool success = microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__destroy(microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence__init(microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary * data = NULL;

  if (size) {
    data = (microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary *)allocator.zero_allocate(size, sizeof(microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence__fini(microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence *
microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence * array = (microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence__destroy(microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence__are_equal(const microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence * lhs, const microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence__copy(
  const microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence * input,
  microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary * data =
      (microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
