// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/FilterAidingMeasurementSummary.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_AIDING_MEASUREMENT_SUMMARY__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_AIDING_MEASUREMENT_SUMMARY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'gnss1'
// Member 'gnss2'
// Member 'dual_antenna'
// Member 'heading'
// Member 'pressure'
// Member 'magnetometer'
// Member 'speed'
#include "microstrain_inertial_msgs/msg/detail/filter_aiding_measurement_summary_indicator__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FilterAidingMeasurementSummary_
{
  using Type = FilterAidingMeasurementSummary_<ContainerAllocator>;

  explicit FilterAidingMeasurementSummary_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : gnss1(_init),
    gnss2(_init),
    dual_antenna(_init),
    heading(_init),
    pressure(_init),
    magnetometer(_init),
    speed(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0;
    }
  }

  explicit FilterAidingMeasurementSummary_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : gnss1(_alloc, _init),
    gnss2(_alloc, _init),
    dual_antenna(_alloc, _init),
    heading(_alloc, _init),
    pressure(_alloc, _init),
    magnetometer(_alloc, _init),
    speed(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0;
    }
  }

  // field types and members
  using _gps_tow_type =
    double;
  _gps_tow_type gps_tow;
  using _gnss1_type =
    microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator_<ContainerAllocator>;
  _gnss1_type gnss1;
  using _gnss2_type =
    microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator_<ContainerAllocator>;
  _gnss2_type gnss2;
  using _dual_antenna_type =
    microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator_<ContainerAllocator>;
  _dual_antenna_type dual_antenna;
  using _heading_type =
    microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator_<ContainerAllocator>;
  _heading_type heading;
  using _pressure_type =
    microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator_<ContainerAllocator>;
  _pressure_type pressure;
  using _magnetometer_type =
    microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator_<ContainerAllocator>;
  _magnetometer_type magnetometer;
  using _speed_type =
    microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator_<ContainerAllocator>;
  _speed_type speed;

  // setters for named parameter idiom
  Type & set__gps_tow(
    const double & _arg)
  {
    this->gps_tow = _arg;
    return *this;
  }
  Type & set__gnss1(
    const microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator_<ContainerAllocator> & _arg)
  {
    this->gnss1 = _arg;
    return *this;
  }
  Type & set__gnss2(
    const microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator_<ContainerAllocator> & _arg)
  {
    this->gnss2 = _arg;
    return *this;
  }
  Type & set__dual_antenna(
    const microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator_<ContainerAllocator> & _arg)
  {
    this->dual_antenna = _arg;
    return *this;
  }
  Type & set__heading(
    const microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator_<ContainerAllocator> & _arg)
  {
    this->heading = _arg;
    return *this;
  }
  Type & set__pressure(
    const microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator_<ContainerAllocator> & _arg)
  {
    this->pressure = _arg;
    return *this;
  }
  Type & set__magnetometer(
    const microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator_<ContainerAllocator> & _arg)
  {
    this->magnetometer = _arg;
    return *this;
  }
  Type & set__speed(
    const microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator_<ContainerAllocator> & _arg)
  {
    this->speed = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary
    std::shared_ptr<microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__FilterAidingMeasurementSummary
    std::shared_ptr<microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FilterAidingMeasurementSummary_ & other) const
  {
    if (this->gps_tow != other.gps_tow) {
      return false;
    }
    if (this->gnss1 != other.gnss1) {
      return false;
    }
    if (this->gnss2 != other.gnss2) {
      return false;
    }
    if (this->dual_antenna != other.dual_antenna) {
      return false;
    }
    if (this->heading != other.heading) {
      return false;
    }
    if (this->pressure != other.pressure) {
      return false;
    }
    if (this->magnetometer != other.magnetometer) {
      return false;
    }
    if (this->speed != other.speed) {
      return false;
    }
    return true;
  }
  bool operator!=(const FilterAidingMeasurementSummary_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FilterAidingMeasurementSummary_

// alias to use template instance with default allocator
using FilterAidingMeasurementSummary =
  microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_AIDING_MEASUREMENT_SUMMARY__STRUCT_HPP_
