// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:msg/FilterAidingMeasurementSummary.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_AIDING_MEASUREMENT_SUMMARY__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_AIDING_MEASUREMENT_SUMMARY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "microstrain_inertial_msgs/msg/detail/filter_aiding_measurement_summary__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'gnss1'
// Member 'gnss2'
// Member 'dual_antenna'
// Member 'heading'
// Member 'pressure'
// Member 'magnetometer'
// Member 'speed'
#include "microstrain_inertial_msgs/msg/detail/filter_aiding_measurement_summary_indicator__traits.hpp"

namespace microstrain_inertial_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const FilterAidingMeasurementSummary & msg,
  std::ostream & out)
{
  out << "{";
  // member: gps_tow
  {
    out << "gps_tow: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_tow, out);
    out << ", ";
  }

  // member: gnss1
  {
    out << "gnss1: ";
    to_flow_style_yaml(msg.gnss1, out);
    out << ", ";
  }

  // member: gnss2
  {
    out << "gnss2: ";
    to_flow_style_yaml(msg.gnss2, out);
    out << ", ";
  }

  // member: dual_antenna
  {
    out << "dual_antenna: ";
    to_flow_style_yaml(msg.dual_antenna, out);
    out << ", ";
  }

  // member: heading
  {
    out << "heading: ";
    to_flow_style_yaml(msg.heading, out);
    out << ", ";
  }

  // member: pressure
  {
    out << "pressure: ";
    to_flow_style_yaml(msg.pressure, out);
    out << ", ";
  }

  // member: magnetometer
  {
    out << "magnetometer: ";
    to_flow_style_yaml(msg.magnetometer, out);
    out << ", ";
  }

  // member: speed
  {
    out << "speed: ";
    to_flow_style_yaml(msg.speed, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FilterAidingMeasurementSummary & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: gps_tow
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_tow: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_tow, out);
    out << "\n";
  }

  // member: gnss1
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gnss1:\n";
    to_block_style_yaml(msg.gnss1, out, indentation + 2);
  }

  // member: gnss2
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gnss2:\n";
    to_block_style_yaml(msg.gnss2, out, indentation + 2);
  }

  // member: dual_antenna
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dual_antenna:\n";
    to_block_style_yaml(msg.dual_antenna, out, indentation + 2);
  }

  // member: heading
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading:\n";
    to_block_style_yaml(msg.heading, out, indentation + 2);
  }

  // member: pressure
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pressure:\n";
    to_block_style_yaml(msg.pressure, out, indentation + 2);
  }

  // member: magnetometer
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "magnetometer:\n";
    to_block_style_yaml(msg.magnetometer, out, indentation + 2);
  }

  // member: speed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed:\n";
    to_block_style_yaml(msg.speed, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FilterAidingMeasurementSummary & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary & msg)
{
  return microstrain_inertial_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary>()
{
  return "microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary";
}

template<>
inline const char * name<microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary>()
{
  return "microstrain_inertial_msgs/msg/FilterAidingMeasurementSummary";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary>
  : std::integral_constant<bool, has_fixed_size<microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator>::value> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary>
  : std::integral_constant<bool, has_bounded_size<microstrain_inertial_msgs::msg::FilterAidingMeasurementSummaryIndicator>::value> {};

template<>
struct is_message<microstrain_inertial_msgs::msg::FilterAidingMeasurementSummary>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_AIDING_MEASUREMENT_SUMMARY__TRAITS_HPP_
