// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from microstrain_inertial_msgs:msg/GNSSAidingStatus.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_AIDING_STATUS__BUILDER_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_AIDING_STATUS__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "microstrain_inertial_msgs/msg/detail/gnss_aiding_status__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace microstrain_inertial_msgs
{

namespace msg
{

namespace builder
{

class Init_GNSSAidingStatus_using_beidou
{
public:
  explicit Init_GNSSAidingStatus_using_beidou(::microstrain_inertial_msgs::msg::GNSSAidingStatus & msg)
  : msg_(msg)
  {}
  ::microstrain_inertial_msgs::msg::GNSSAidingStatus using_beidou(::microstrain_inertial_msgs::msg::GNSSAidingStatus::_using_beidou_type arg)
  {
    msg_.using_beidou = std::move(arg);
    return std::move(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSAidingStatus msg_;
};

class Init_GNSSAidingStatus_using_galileo
{
public:
  explicit Init_GNSSAidingStatus_using_galileo(::microstrain_inertial_msgs::msg::GNSSAidingStatus & msg)
  : msg_(msg)
  {}
  Init_GNSSAidingStatus_using_beidou using_galileo(::microstrain_inertial_msgs::msg::GNSSAidingStatus::_using_galileo_type arg)
  {
    msg_.using_galileo = std::move(arg);
    return Init_GNSSAidingStatus_using_beidou(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSAidingStatus msg_;
};

class Init_GNSSAidingStatus_using_glonass
{
public:
  explicit Init_GNSSAidingStatus_using_glonass(::microstrain_inertial_msgs::msg::GNSSAidingStatus & msg)
  : msg_(msg)
  {}
  Init_GNSSAidingStatus_using_galileo using_glonass(::microstrain_inertial_msgs::msg::GNSSAidingStatus::_using_glonass_type arg)
  {
    msg_.using_glonass = std::move(arg);
    return Init_GNSSAidingStatus_using_galileo(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSAidingStatus msg_;
};

class Init_GNSSAidingStatus_using_gps
{
public:
  explicit Init_GNSSAidingStatus_using_gps(::microstrain_inertial_msgs::msg::GNSSAidingStatus & msg)
  : msg_(msg)
  {}
  Init_GNSSAidingStatus_using_glonass using_gps(::microstrain_inertial_msgs::msg::GNSSAidingStatus::_using_gps_type arg)
  {
    msg_.using_gps = std::move(arg);
    return Init_GNSSAidingStatus_using_glonass(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSAidingStatus msg_;
};

class Init_GNSSAidingStatus_integer_fix
{
public:
  explicit Init_GNSSAidingStatus_integer_fix(::microstrain_inertial_msgs::msg::GNSSAidingStatus & msg)
  : msg_(msg)
  {}
  Init_GNSSAidingStatus_using_gps integer_fix(::microstrain_inertial_msgs::msg::GNSSAidingStatus::_integer_fix_type arg)
  {
    msg_.integer_fix = std::move(arg);
    return Init_GNSSAidingStatus_using_gps(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSAidingStatus msg_;
};

class Init_GNSSAidingStatus_differential_corrections
{
public:
  explicit Init_GNSSAidingStatus_differential_corrections(::microstrain_inertial_msgs::msg::GNSSAidingStatus & msg)
  : msg_(msg)
  {}
  Init_GNSSAidingStatus_integer_fix differential_corrections(::microstrain_inertial_msgs::msg::GNSSAidingStatus::_differential_corrections_type arg)
  {
    msg_.differential_corrections = std::move(arg);
    return Init_GNSSAidingStatus_integer_fix(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSAidingStatus msg_;
};

class Init_GNSSAidingStatus_tight_coupling
{
public:
  explicit Init_GNSSAidingStatus_tight_coupling(::microstrain_inertial_msgs::msg::GNSSAidingStatus & msg)
  : msg_(msg)
  {}
  Init_GNSSAidingStatus_differential_corrections tight_coupling(::microstrain_inertial_msgs::msg::GNSSAidingStatus::_tight_coupling_type arg)
  {
    msg_.tight_coupling = std::move(arg);
    return Init_GNSSAidingStatus_differential_corrections(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSAidingStatus msg_;
};

class Init_GNSSAidingStatus_has_position_fix
{
public:
  explicit Init_GNSSAidingStatus_has_position_fix(::microstrain_inertial_msgs::msg::GNSSAidingStatus & msg)
  : msg_(msg)
  {}
  Init_GNSSAidingStatus_tight_coupling has_position_fix(::microstrain_inertial_msgs::msg::GNSSAidingStatus::_has_position_fix_type arg)
  {
    msg_.has_position_fix = std::move(arg);
    return Init_GNSSAidingStatus_tight_coupling(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSAidingStatus msg_;
};

class Init_GNSSAidingStatus_gps_tow
{
public:
  Init_GNSSAidingStatus_gps_tow()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_GNSSAidingStatus_has_position_fix gps_tow(::microstrain_inertial_msgs::msg::GNSSAidingStatus::_gps_tow_type arg)
  {
    msg_.gps_tow = std::move(arg);
    return Init_GNSSAidingStatus_has_position_fix(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSAidingStatus msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::microstrain_inertial_msgs::msg::GNSSAidingStatus>()
{
  return microstrain_inertial_msgs::msg::builder::Init_GNSSAidingStatus_gps_tow();
}

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_AIDING_STATUS__BUILDER_HPP_
