// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from microstrain_inertial_msgs:msg/GNSSAidingStatus.idl
// generated code does not contain a copyright notice
#include "microstrain_inertial_msgs/msg/detail/gnss_aiding_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
microstrain_inertial_msgs__msg__GNSSAidingStatus__init(microstrain_inertial_msgs__msg__GNSSAidingStatus * msg)
{
  if (!msg) {
    return false;
  }
  // gps_tow
  // has_position_fix
  // tight_coupling
  // differential_corrections
  // integer_fix
  // using_gps
  // using_glonass
  // using_galileo
  // using_beidou
  return true;
}

void
microstrain_inertial_msgs__msg__GNSSAidingStatus__fini(microstrain_inertial_msgs__msg__GNSSAidingStatus * msg)
{
  if (!msg) {
    return;
  }
  // gps_tow
  // has_position_fix
  // tight_coupling
  // differential_corrections
  // integer_fix
  // using_gps
  // using_glonass
  // using_galileo
  // using_beidou
}

bool
microstrain_inertial_msgs__msg__GNSSAidingStatus__are_equal(const microstrain_inertial_msgs__msg__GNSSAidingStatus * lhs, const microstrain_inertial_msgs__msg__GNSSAidingStatus * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // gps_tow
  if (lhs->gps_tow != rhs->gps_tow) {
    return false;
  }
  // has_position_fix
  if (lhs->has_position_fix != rhs->has_position_fix) {
    return false;
  }
  // tight_coupling
  if (lhs->tight_coupling != rhs->tight_coupling) {
    return false;
  }
  // differential_corrections
  if (lhs->differential_corrections != rhs->differential_corrections) {
    return false;
  }
  // integer_fix
  if (lhs->integer_fix != rhs->integer_fix) {
    return false;
  }
  // using_gps
  if (lhs->using_gps != rhs->using_gps) {
    return false;
  }
  // using_glonass
  if (lhs->using_glonass != rhs->using_glonass) {
    return false;
  }
  // using_galileo
  if (lhs->using_galileo != rhs->using_galileo) {
    return false;
  }
  // using_beidou
  if (lhs->using_beidou != rhs->using_beidou) {
    return false;
  }
  return true;
}

bool
microstrain_inertial_msgs__msg__GNSSAidingStatus__copy(
  const microstrain_inertial_msgs__msg__GNSSAidingStatus * input,
  microstrain_inertial_msgs__msg__GNSSAidingStatus * output)
{
  if (!input || !output) {
    return false;
  }
  // gps_tow
  output->gps_tow = input->gps_tow;
  // has_position_fix
  output->has_position_fix = input->has_position_fix;
  // tight_coupling
  output->tight_coupling = input->tight_coupling;
  // differential_corrections
  output->differential_corrections = input->differential_corrections;
  // integer_fix
  output->integer_fix = input->integer_fix;
  // using_gps
  output->using_gps = input->using_gps;
  // using_glonass
  output->using_glonass = input->using_glonass;
  // using_galileo
  output->using_galileo = input->using_galileo;
  // using_beidou
  output->using_beidou = input->using_beidou;
  return true;
}

microstrain_inertial_msgs__msg__GNSSAidingStatus *
microstrain_inertial_msgs__msg__GNSSAidingStatus__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__GNSSAidingStatus * msg = (microstrain_inertial_msgs__msg__GNSSAidingStatus *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__GNSSAidingStatus), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(microstrain_inertial_msgs__msg__GNSSAidingStatus));
  bool success = microstrain_inertial_msgs__msg__GNSSAidingStatus__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
microstrain_inertial_msgs__msg__GNSSAidingStatus__destroy(microstrain_inertial_msgs__msg__GNSSAidingStatus * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    microstrain_inertial_msgs__msg__GNSSAidingStatus__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence__init(microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__GNSSAidingStatus * data = NULL;

  if (size) {
    data = (microstrain_inertial_msgs__msg__GNSSAidingStatus *)allocator.zero_allocate(size, sizeof(microstrain_inertial_msgs__msg__GNSSAidingStatus), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = microstrain_inertial_msgs__msg__GNSSAidingStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        microstrain_inertial_msgs__msg__GNSSAidingStatus__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence__fini(microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      microstrain_inertial_msgs__msg__GNSSAidingStatus__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence *
microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence * array = (microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence__destroy(microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence__are_equal(const microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence * lhs, const microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!microstrain_inertial_msgs__msg__GNSSAidingStatus__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence__copy(
  const microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence * input,
  microstrain_inertial_msgs__msg__GNSSAidingStatus__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(microstrain_inertial_msgs__msg__GNSSAidingStatus);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    microstrain_inertial_msgs__msg__GNSSAidingStatus * data =
      (microstrain_inertial_msgs__msg__GNSSAidingStatus *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!microstrain_inertial_msgs__msg__GNSSAidingStatus__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          microstrain_inertial_msgs__msg__GNSSAidingStatus__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!microstrain_inertial_msgs__msg__GNSSAidingStatus__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
