// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/GNSSAidingStatus.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_AIDING_STATUS__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_AIDING_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__GNSSAidingStatus __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__GNSSAidingStatus __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GNSSAidingStatus_
{
  using Type = GNSSAidingStatus_<ContainerAllocator>;

  explicit GNSSAidingStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0;
      this->has_position_fix = false;
      this->tight_coupling = false;
      this->differential_corrections = false;
      this->integer_fix = false;
      this->using_gps = false;
      this->using_glonass = false;
      this->using_galileo = false;
      this->using_beidou = false;
    }
  }

  explicit GNSSAidingStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0;
      this->has_position_fix = false;
      this->tight_coupling = false;
      this->differential_corrections = false;
      this->integer_fix = false;
      this->using_gps = false;
      this->using_glonass = false;
      this->using_galileo = false;
      this->using_beidou = false;
    }
  }

  // field types and members
  using _gps_tow_type =
    double;
  _gps_tow_type gps_tow;
  using _has_position_fix_type =
    bool;
  _has_position_fix_type has_position_fix;
  using _tight_coupling_type =
    bool;
  _tight_coupling_type tight_coupling;
  using _differential_corrections_type =
    bool;
  _differential_corrections_type differential_corrections;
  using _integer_fix_type =
    bool;
  _integer_fix_type integer_fix;
  using _using_gps_type =
    bool;
  _using_gps_type using_gps;
  using _using_glonass_type =
    bool;
  _using_glonass_type using_glonass;
  using _using_galileo_type =
    bool;
  _using_galileo_type using_galileo;
  using _using_beidou_type =
    bool;
  _using_beidou_type using_beidou;

  // setters for named parameter idiom
  Type & set__gps_tow(
    const double & _arg)
  {
    this->gps_tow = _arg;
    return *this;
  }
  Type & set__has_position_fix(
    const bool & _arg)
  {
    this->has_position_fix = _arg;
    return *this;
  }
  Type & set__tight_coupling(
    const bool & _arg)
  {
    this->tight_coupling = _arg;
    return *this;
  }
  Type & set__differential_corrections(
    const bool & _arg)
  {
    this->differential_corrections = _arg;
    return *this;
  }
  Type & set__integer_fix(
    const bool & _arg)
  {
    this->integer_fix = _arg;
    return *this;
  }
  Type & set__using_gps(
    const bool & _arg)
  {
    this->using_gps = _arg;
    return *this;
  }
  Type & set__using_glonass(
    const bool & _arg)
  {
    this->using_glonass = _arg;
    return *this;
  }
  Type & set__using_galileo(
    const bool & _arg)
  {
    this->using_galileo = _arg;
    return *this;
  }
  Type & set__using_beidou(
    const bool & _arg)
  {
    this->using_beidou = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::GNSSAidingStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::GNSSAidingStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSAidingStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSAidingStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::GNSSAidingStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::GNSSAidingStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::GNSSAidingStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::GNSSAidingStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::GNSSAidingStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::GNSSAidingStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__GNSSAidingStatus
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSAidingStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__GNSSAidingStatus
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSAidingStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GNSSAidingStatus_ & other) const
  {
    if (this->gps_tow != other.gps_tow) {
      return false;
    }
    if (this->has_position_fix != other.has_position_fix) {
      return false;
    }
    if (this->tight_coupling != other.tight_coupling) {
      return false;
    }
    if (this->differential_corrections != other.differential_corrections) {
      return false;
    }
    if (this->integer_fix != other.integer_fix) {
      return false;
    }
    if (this->using_gps != other.using_gps) {
      return false;
    }
    if (this->using_glonass != other.using_glonass) {
      return false;
    }
    if (this->using_galileo != other.using_galileo) {
      return false;
    }
    if (this->using_beidou != other.using_beidou) {
      return false;
    }
    return true;
  }
  bool operator!=(const GNSSAidingStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GNSSAidingStatus_

// alias to use template instance with default allocator
using GNSSAidingStatus =
  microstrain_inertial_msgs::msg::GNSSAidingStatus_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_AIDING_STATUS__STRUCT_HPP_
