// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from microstrain_inertial_msgs:msg/GNSSFixInfo.idl
// generated code does not contain a copyright notice
#include "microstrain_inertial_msgs/msg/detail/gnss_fix_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
microstrain_inertial_msgs__msg__GNSSFixInfo__init(microstrain_inertial_msgs__msg__GNSSFixInfo * msg)
{
  if (!msg) {
    return false;
  }
  // fix_type
  // num_sv
  // sbas_used
  // dngss_used
  return true;
}

void
microstrain_inertial_msgs__msg__GNSSFixInfo__fini(microstrain_inertial_msgs__msg__GNSSFixInfo * msg)
{
  if (!msg) {
    return;
  }
  // fix_type
  // num_sv
  // sbas_used
  // dngss_used
}

bool
microstrain_inertial_msgs__msg__GNSSFixInfo__are_equal(const microstrain_inertial_msgs__msg__GNSSFixInfo * lhs, const microstrain_inertial_msgs__msg__GNSSFixInfo * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // fix_type
  if (lhs->fix_type != rhs->fix_type) {
    return false;
  }
  // num_sv
  if (lhs->num_sv != rhs->num_sv) {
    return false;
  }
  // sbas_used
  if (lhs->sbas_used != rhs->sbas_used) {
    return false;
  }
  // dngss_used
  if (lhs->dngss_used != rhs->dngss_used) {
    return false;
  }
  return true;
}

bool
microstrain_inertial_msgs__msg__GNSSFixInfo__copy(
  const microstrain_inertial_msgs__msg__GNSSFixInfo * input,
  microstrain_inertial_msgs__msg__GNSSFixInfo * output)
{
  if (!input || !output) {
    return false;
  }
  // fix_type
  output->fix_type = input->fix_type;
  // num_sv
  output->num_sv = input->num_sv;
  // sbas_used
  output->sbas_used = input->sbas_used;
  // dngss_used
  output->dngss_used = input->dngss_used;
  return true;
}

microstrain_inertial_msgs__msg__GNSSFixInfo *
microstrain_inertial_msgs__msg__GNSSFixInfo__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__GNSSFixInfo * msg = (microstrain_inertial_msgs__msg__GNSSFixInfo *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__GNSSFixInfo), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(microstrain_inertial_msgs__msg__GNSSFixInfo));
  bool success = microstrain_inertial_msgs__msg__GNSSFixInfo__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
microstrain_inertial_msgs__msg__GNSSFixInfo__destroy(microstrain_inertial_msgs__msg__GNSSFixInfo * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    microstrain_inertial_msgs__msg__GNSSFixInfo__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence__init(microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__GNSSFixInfo * data = NULL;

  if (size) {
    data = (microstrain_inertial_msgs__msg__GNSSFixInfo *)allocator.zero_allocate(size, sizeof(microstrain_inertial_msgs__msg__GNSSFixInfo), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = microstrain_inertial_msgs__msg__GNSSFixInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        microstrain_inertial_msgs__msg__GNSSFixInfo__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence__fini(microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      microstrain_inertial_msgs__msg__GNSSFixInfo__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence *
microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence * array = (microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence__destroy(microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence__are_equal(const microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence * lhs, const microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!microstrain_inertial_msgs__msg__GNSSFixInfo__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence__copy(
  const microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence * input,
  microstrain_inertial_msgs__msg__GNSSFixInfo__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(microstrain_inertial_msgs__msg__GNSSFixInfo);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    microstrain_inertial_msgs__msg__GNSSFixInfo * data =
      (microstrain_inertial_msgs__msg__GNSSFixInfo *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!microstrain_inertial_msgs__msg__GNSSFixInfo__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          microstrain_inertial_msgs__msg__GNSSFixInfo__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!microstrain_inertial_msgs__msg__GNSSFixInfo__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
