// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/GNSSFixInfo.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_FIX_INFO__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_FIX_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__GNSSFixInfo __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__GNSSFixInfo __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GNSSFixInfo_
{
  using Type = GNSSFixInfo_<ContainerAllocator>;

  explicit GNSSFixInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->fix_type = 0;
      this->num_sv = 0;
      this->sbas_used = false;
      this->dngss_used = false;
    }
  }

  explicit GNSSFixInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->fix_type = 0;
      this->num_sv = 0;
      this->sbas_used = false;
      this->dngss_used = false;
    }
  }

  // field types and members
  using _fix_type_type =
    uint8_t;
  _fix_type_type fix_type;
  using _num_sv_type =
    uint8_t;
  _num_sv_type num_sv;
  using _sbas_used_type =
    bool;
  _sbas_used_type sbas_used;
  using _dngss_used_type =
    bool;
  _dngss_used_type dngss_used;

  // setters for named parameter idiom
  Type & set__fix_type(
    const uint8_t & _arg)
  {
    this->fix_type = _arg;
    return *this;
  }
  Type & set__num_sv(
    const uint8_t & _arg)
  {
    this->num_sv = _arg;
    return *this;
  }
  Type & set__sbas_used(
    const bool & _arg)
  {
    this->sbas_used = _arg;
    return *this;
  }
  Type & set__dngss_used(
    const bool & _arg)
  {
    this->dngss_used = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t FIX_3D =
    0u;
  static constexpr uint8_t FIX_2D =
    1u;
  static constexpr uint8_t FIX_TIME_ONLY =
    2u;
  static constexpr uint8_t FIX_NONE =
    3u;
  static constexpr uint8_t FIX_INVALID =
    4u;
  static constexpr uint8_t FIX_RTK_FLOAT =
    5u;
  static constexpr uint8_t FIX_RTK_FIXED =
    6u;

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::GNSSFixInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::GNSSFixInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSFixInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSFixInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::GNSSFixInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::GNSSFixInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::GNSSFixInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::GNSSFixInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::GNSSFixInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::GNSSFixInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__GNSSFixInfo
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSFixInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__GNSSFixInfo
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSFixInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GNSSFixInfo_ & other) const
  {
    if (this->fix_type != other.fix_type) {
      return false;
    }
    if (this->num_sv != other.num_sv) {
      return false;
    }
    if (this->sbas_used != other.sbas_used) {
      return false;
    }
    if (this->dngss_used != other.dngss_used) {
      return false;
    }
    return true;
  }
  bool operator!=(const GNSSFixInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GNSSFixInfo_

// alias to use template instance with default allocator
using GNSSFixInfo =
  microstrain_inertial_msgs::msg::GNSSFixInfo_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GNSSFixInfo_<ContainerAllocator>::FIX_3D;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GNSSFixInfo_<ContainerAllocator>::FIX_2D;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GNSSFixInfo_<ContainerAllocator>::FIX_TIME_ONLY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GNSSFixInfo_<ContainerAllocator>::FIX_NONE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GNSSFixInfo_<ContainerAllocator>::FIX_INVALID;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GNSSFixInfo_<ContainerAllocator>::FIX_RTK_FLOAT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GNSSFixInfo_<ContainerAllocator>::FIX_RTK_FIXED;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_FIX_INFO__STRUCT_HPP_
