// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from microstrain_inertial_msgs:msg/GNSSSbasInfo.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_SBAS_INFO__STRUCT_H_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_SBAS_INFO__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SBAS_SYSTEM_UNKNOWN'.
/**
  * Possible values for the sbas_system field
 */
enum
{
  microstrain_inertial_msgs__msg__GNSSSbasInfo__SBAS_SYSTEM_UNKNOWN = 0
};

/// Constant 'SBAS_SYSTEM_WAAS'.
enum
{
  microstrain_inertial_msgs__msg__GNSSSbasInfo__SBAS_SYSTEM_WAAS = 1
};

/// Constant 'SBAS_SYSTEM_EGNOS'.
enum
{
  microstrain_inertial_msgs__msg__GNSSSbasInfo__SBAS_SYSTEM_EGNOS = 2
};

/// Constant 'SBAS_SYSTEM_MSAS'.
enum
{
  microstrain_inertial_msgs__msg__GNSSSbasInfo__SBAS_SYSTEM_MSAS = 3
};

/// Constant 'SBAS_SYSTEM_GAGAN'.
enum
{
  microstrain_inertial_msgs__msg__GNSSSbasInfo__SBAS_SYSTEM_GAGAN = 4
};

/// Struct defined in msg/GNSSSbasInfo in the package microstrain_inertial_msgs.
typedef struct microstrain_inertial_msgs__msg__GNSSSbasInfo
{
  float gps_tow;
  uint16_t gps_week_number;
  /// Must be equal to one of the SBAS_SYSTEM_* values in this message
  uint8_t sbas_system;
  uint8_t sbas_id;
  uint8_t count;
  /// Parsed out version of the SBAS status bitfield
  bool status_range_available;
  bool status_corrections_available;
  bool status_integrity_available;
  bool status_test_mode;
  /// Valid flags can be parsed per the manual to determine which fields are valid
  uint16_t valid_flags;
} microstrain_inertial_msgs__msg__GNSSSbasInfo;

// Struct for a sequence of microstrain_inertial_msgs__msg__GNSSSbasInfo.
typedef struct microstrain_inertial_msgs__msg__GNSSSbasInfo__Sequence
{
  microstrain_inertial_msgs__msg__GNSSSbasInfo * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} microstrain_inertial_msgs__msg__GNSSSbasInfo__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_SBAS_INFO__STRUCT_H_
