// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/GNSSSbasInfo.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_SBAS_INFO__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_SBAS_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__GNSSSbasInfo __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__GNSSSbasInfo __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GNSSSbasInfo_
{
  using Type = GNSSSbasInfo_<ContainerAllocator>;

  explicit GNSSSbasInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0f;
      this->gps_week_number = 0;
      this->sbas_system = 0;
      this->sbas_id = 0;
      this->count = 0;
      this->status_range_available = false;
      this->status_corrections_available = false;
      this->status_integrity_available = false;
      this->status_test_mode = false;
      this->valid_flags = 0;
    }
  }

  explicit GNSSSbasInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0f;
      this->gps_week_number = 0;
      this->sbas_system = 0;
      this->sbas_id = 0;
      this->count = 0;
      this->status_range_available = false;
      this->status_corrections_available = false;
      this->status_integrity_available = false;
      this->status_test_mode = false;
      this->valid_flags = 0;
    }
  }

  // field types and members
  using _gps_tow_type =
    float;
  _gps_tow_type gps_tow;
  using _gps_week_number_type =
    uint16_t;
  _gps_week_number_type gps_week_number;
  using _sbas_system_type =
    uint8_t;
  _sbas_system_type sbas_system;
  using _sbas_id_type =
    uint8_t;
  _sbas_id_type sbas_id;
  using _count_type =
    uint8_t;
  _count_type count;
  using _status_range_available_type =
    bool;
  _status_range_available_type status_range_available;
  using _status_corrections_available_type =
    bool;
  _status_corrections_available_type status_corrections_available;
  using _status_integrity_available_type =
    bool;
  _status_integrity_available_type status_integrity_available;
  using _status_test_mode_type =
    bool;
  _status_test_mode_type status_test_mode;
  using _valid_flags_type =
    uint16_t;
  _valid_flags_type valid_flags;

  // setters for named parameter idiom
  Type & set__gps_tow(
    const float & _arg)
  {
    this->gps_tow = _arg;
    return *this;
  }
  Type & set__gps_week_number(
    const uint16_t & _arg)
  {
    this->gps_week_number = _arg;
    return *this;
  }
  Type & set__sbas_system(
    const uint8_t & _arg)
  {
    this->sbas_system = _arg;
    return *this;
  }
  Type & set__sbas_id(
    const uint8_t & _arg)
  {
    this->sbas_id = _arg;
    return *this;
  }
  Type & set__count(
    const uint8_t & _arg)
  {
    this->count = _arg;
    return *this;
  }
  Type & set__status_range_available(
    const bool & _arg)
  {
    this->status_range_available = _arg;
    return *this;
  }
  Type & set__status_corrections_available(
    const bool & _arg)
  {
    this->status_corrections_available = _arg;
    return *this;
  }
  Type & set__status_integrity_available(
    const bool & _arg)
  {
    this->status_integrity_available = _arg;
    return *this;
  }
  Type & set__status_test_mode(
    const bool & _arg)
  {
    this->status_test_mode = _arg;
    return *this;
  }
  Type & set__valid_flags(
    const uint16_t & _arg)
  {
    this->valid_flags = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t SBAS_SYSTEM_UNKNOWN =
    0u;
  static constexpr uint8_t SBAS_SYSTEM_WAAS =
    1u;
  static constexpr uint8_t SBAS_SYSTEM_EGNOS =
    2u;
  static constexpr uint8_t SBAS_SYSTEM_MSAS =
    3u;
  static constexpr uint8_t SBAS_SYSTEM_GAGAN =
    4u;

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::GNSSSbasInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::GNSSSbasInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSSbasInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSSbasInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::GNSSSbasInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::GNSSSbasInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::GNSSSbasInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::GNSSSbasInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::GNSSSbasInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::GNSSSbasInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__GNSSSbasInfo
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSSbasInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__GNSSSbasInfo
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSSbasInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GNSSSbasInfo_ & other) const
  {
    if (this->gps_tow != other.gps_tow) {
      return false;
    }
    if (this->gps_week_number != other.gps_week_number) {
      return false;
    }
    if (this->sbas_system != other.sbas_system) {
      return false;
    }
    if (this->sbas_id != other.sbas_id) {
      return false;
    }
    if (this->count != other.count) {
      return false;
    }
    if (this->status_range_available != other.status_range_available) {
      return false;
    }
    if (this->status_corrections_available != other.status_corrections_available) {
      return false;
    }
    if (this->status_integrity_available != other.status_integrity_available) {
      return false;
    }
    if (this->status_test_mode != other.status_test_mode) {
      return false;
    }
    if (this->valid_flags != other.valid_flags) {
      return false;
    }
    return true;
  }
  bool operator!=(const GNSSSbasInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GNSSSbasInfo_

// alias to use template instance with default allocator
using GNSSSbasInfo =
  microstrain_inertial_msgs::msg::GNSSSbasInfo_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GNSSSbasInfo_<ContainerAllocator>::SBAS_SYSTEM_UNKNOWN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GNSSSbasInfo_<ContainerAllocator>::SBAS_SYSTEM_WAAS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GNSSSbasInfo_<ContainerAllocator>::SBAS_SYSTEM_EGNOS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GNSSSbasInfo_<ContainerAllocator>::SBAS_SYSTEM_MSAS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GNSSSbasInfo_<ContainerAllocator>::SBAS_SYSTEM_GAGAN;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_SBAS_INFO__STRUCT_HPP_
