// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:msg/GNSSSbasInfo.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_SBAS_INFO__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_SBAS_INFO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "microstrain_inertial_msgs/msg/detail/gnss_sbas_info__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace microstrain_inertial_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const GNSSSbasInfo & msg,
  std::ostream & out)
{
  out << "{";
  // member: gps_tow
  {
    out << "gps_tow: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_tow, out);
    out << ", ";
  }

  // member: gps_week_number
  {
    out << "gps_week_number: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_week_number, out);
    out << ", ";
  }

  // member: sbas_system
  {
    out << "sbas_system: ";
    rosidl_generator_traits::value_to_yaml(msg.sbas_system, out);
    out << ", ";
  }

  // member: sbas_id
  {
    out << "sbas_id: ";
    rosidl_generator_traits::value_to_yaml(msg.sbas_id, out);
    out << ", ";
  }

  // member: count
  {
    out << "count: ";
    rosidl_generator_traits::value_to_yaml(msg.count, out);
    out << ", ";
  }

  // member: status_range_available
  {
    out << "status_range_available: ";
    rosidl_generator_traits::value_to_yaml(msg.status_range_available, out);
    out << ", ";
  }

  // member: status_corrections_available
  {
    out << "status_corrections_available: ";
    rosidl_generator_traits::value_to_yaml(msg.status_corrections_available, out);
    out << ", ";
  }

  // member: status_integrity_available
  {
    out << "status_integrity_available: ";
    rosidl_generator_traits::value_to_yaml(msg.status_integrity_available, out);
    out << ", ";
  }

  // member: status_test_mode
  {
    out << "status_test_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.status_test_mode, out);
    out << ", ";
  }

  // member: valid_flags
  {
    out << "valid_flags: ";
    rosidl_generator_traits::value_to_yaml(msg.valid_flags, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GNSSSbasInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: gps_tow
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_tow: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_tow, out);
    out << "\n";
  }

  // member: gps_week_number
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_week_number: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_week_number, out);
    out << "\n";
  }

  // member: sbas_system
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sbas_system: ";
    rosidl_generator_traits::value_to_yaml(msg.sbas_system, out);
    out << "\n";
  }

  // member: sbas_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sbas_id: ";
    rosidl_generator_traits::value_to_yaml(msg.sbas_id, out);
    out << "\n";
  }

  // member: count
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "count: ";
    rosidl_generator_traits::value_to_yaml(msg.count, out);
    out << "\n";
  }

  // member: status_range_available
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status_range_available: ";
    rosidl_generator_traits::value_to_yaml(msg.status_range_available, out);
    out << "\n";
  }

  // member: status_corrections_available
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status_corrections_available: ";
    rosidl_generator_traits::value_to_yaml(msg.status_corrections_available, out);
    out << "\n";
  }

  // member: status_integrity_available
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status_integrity_available: ";
    rosidl_generator_traits::value_to_yaml(msg.status_integrity_available, out);
    out << "\n";
  }

  // member: status_test_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status_test_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.status_test_mode, out);
    out << "\n";
  }

  // member: valid_flags
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "valid_flags: ";
    rosidl_generator_traits::value_to_yaml(msg.valid_flags, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GNSSSbasInfo & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::msg::GNSSSbasInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::msg::GNSSSbasInfo & msg)
{
  return microstrain_inertial_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::msg::GNSSSbasInfo>()
{
  return "microstrain_inertial_msgs::msg::GNSSSbasInfo";
}

template<>
inline const char * name<microstrain_inertial_msgs::msg::GNSSSbasInfo>()
{
  return "microstrain_inertial_msgs/msg/GNSSSbasInfo";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::msg::GNSSSbasInfo>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::msg::GNSSSbasInfo>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::msg::GNSSSbasInfo>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_SBAS_INFO__TRAITS_HPP_
