// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/GPSCorrelationTimestampStamped.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GPS_CORRELATION_TIMESTAMP_STAMPED__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GPS_CORRELATION_TIMESTAMP_STAMPED__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'gps_cor'
#include "microstrain_inertial_msgs/msg/detail/gps_correlation_timestamp__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__GPSCorrelationTimestampStamped __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__GPSCorrelationTimestampStamped __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GPSCorrelationTimestampStamped_
{
  using Type = GPSCorrelationTimestampStamped_<ContainerAllocator>;

  explicit GPSCorrelationTimestampStamped_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    gps_cor(_init)
  {
    (void)_init;
  }

  explicit GPSCorrelationTimestampStamped_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    gps_cor(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _gps_cor_type =
    microstrain_inertial_msgs::msg::GPSCorrelationTimestamp_<ContainerAllocator>;
  _gps_cor_type gps_cor;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__gps_cor(
    const microstrain_inertial_msgs::msg::GPSCorrelationTimestamp_<ContainerAllocator> & _arg)
  {
    this->gps_cor = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::GPSCorrelationTimestampStamped_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::GPSCorrelationTimestampStamped_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestampStamped_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestampStamped_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::GPSCorrelationTimestampStamped_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestampStamped_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::GPSCorrelationTimestampStamped_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestampStamped_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestampStamped_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestampStamped_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__GPSCorrelationTimestampStamped
    std::shared_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestampStamped_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__GPSCorrelationTimestampStamped
    std::shared_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestampStamped_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GPSCorrelationTimestampStamped_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->gps_cor != other.gps_cor) {
      return false;
    }
    return true;
  }
  bool operator!=(const GPSCorrelationTimestampStamped_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GPSCorrelationTimestampStamped_

// alias to use template instance with default allocator
using GPSCorrelationTimestampStamped =
  microstrain_inertial_msgs::msg::GPSCorrelationTimestampStamped_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GPS_CORRELATION_TIMESTAMP_STAMPED__STRUCT_HPP_
