// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/ImuOverrangeStatus.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__IMU_OVERRANGE_STATUS__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__IMU_OVERRANGE_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__ImuOverrangeStatus __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__ImuOverrangeStatus __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ImuOverrangeStatus_
{
  using Type = ImuOverrangeStatus_<ContainerAllocator>;

  explicit ImuOverrangeStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status_accel_x = false;
      this->status_accel_y = false;
      this->status_accel_z = false;
      this->status_gyro_x = false;
      this->status_gyro_y = false;
      this->status_gyro_z = false;
      this->status_mag_x = false;
      this->status_mag_y = false;
      this->status_mag_z = false;
      this->status_press = false;
    }
  }

  explicit ImuOverrangeStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status_accel_x = false;
      this->status_accel_y = false;
      this->status_accel_z = false;
      this->status_gyro_x = false;
      this->status_gyro_y = false;
      this->status_gyro_z = false;
      this->status_mag_x = false;
      this->status_mag_y = false;
      this->status_mag_z = false;
      this->status_press = false;
    }
  }

  // field types and members
  using _status_accel_x_type =
    bool;
  _status_accel_x_type status_accel_x;
  using _status_accel_y_type =
    bool;
  _status_accel_y_type status_accel_y;
  using _status_accel_z_type =
    bool;
  _status_accel_z_type status_accel_z;
  using _status_gyro_x_type =
    bool;
  _status_gyro_x_type status_gyro_x;
  using _status_gyro_y_type =
    bool;
  _status_gyro_y_type status_gyro_y;
  using _status_gyro_z_type =
    bool;
  _status_gyro_z_type status_gyro_z;
  using _status_mag_x_type =
    bool;
  _status_mag_x_type status_mag_x;
  using _status_mag_y_type =
    bool;
  _status_mag_y_type status_mag_y;
  using _status_mag_z_type =
    bool;
  _status_mag_z_type status_mag_z;
  using _status_press_type =
    bool;
  _status_press_type status_press;

  // setters for named parameter idiom
  Type & set__status_accel_x(
    const bool & _arg)
  {
    this->status_accel_x = _arg;
    return *this;
  }
  Type & set__status_accel_y(
    const bool & _arg)
  {
    this->status_accel_y = _arg;
    return *this;
  }
  Type & set__status_accel_z(
    const bool & _arg)
  {
    this->status_accel_z = _arg;
    return *this;
  }
  Type & set__status_gyro_x(
    const bool & _arg)
  {
    this->status_gyro_x = _arg;
    return *this;
  }
  Type & set__status_gyro_y(
    const bool & _arg)
  {
    this->status_gyro_y = _arg;
    return *this;
  }
  Type & set__status_gyro_z(
    const bool & _arg)
  {
    this->status_gyro_z = _arg;
    return *this;
  }
  Type & set__status_mag_x(
    const bool & _arg)
  {
    this->status_mag_x = _arg;
    return *this;
  }
  Type & set__status_mag_y(
    const bool & _arg)
  {
    this->status_mag_y = _arg;
    return *this;
  }
  Type & set__status_mag_z(
    const bool & _arg)
  {
    this->status_mag_z = _arg;
    return *this;
  }
  Type & set__status_press(
    const bool & _arg)
  {
    this->status_press = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::ImuOverrangeStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::ImuOverrangeStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::ImuOverrangeStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::ImuOverrangeStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::ImuOverrangeStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::ImuOverrangeStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::ImuOverrangeStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::ImuOverrangeStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::ImuOverrangeStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::ImuOverrangeStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__ImuOverrangeStatus
    std::shared_ptr<microstrain_inertial_msgs::msg::ImuOverrangeStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__ImuOverrangeStatus
    std::shared_ptr<microstrain_inertial_msgs::msg::ImuOverrangeStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ImuOverrangeStatus_ & other) const
  {
    if (this->status_accel_x != other.status_accel_x) {
      return false;
    }
    if (this->status_accel_y != other.status_accel_y) {
      return false;
    }
    if (this->status_accel_z != other.status_accel_z) {
      return false;
    }
    if (this->status_gyro_x != other.status_gyro_x) {
      return false;
    }
    if (this->status_gyro_y != other.status_gyro_y) {
      return false;
    }
    if (this->status_gyro_z != other.status_gyro_z) {
      return false;
    }
    if (this->status_mag_x != other.status_mag_x) {
      return false;
    }
    if (this->status_mag_y != other.status_mag_y) {
      return false;
    }
    if (this->status_mag_z != other.status_mag_z) {
      return false;
    }
    if (this->status_press != other.status_press) {
      return false;
    }
    return true;
  }
  bool operator!=(const ImuOverrangeStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ImuOverrangeStatus_

// alias to use template instance with default allocator
using ImuOverrangeStatus =
  microstrain_inertial_msgs::msg::ImuOverrangeStatus_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__IMU_OVERRANGE_STATUS__STRUCT_HPP_
