// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from microstrain_inertial_msgs:msg/InputSpeedMeasurement.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__INPUT_SPEED_MEASUREMENT__STRUCT_H_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__INPUT_SPEED_MEASUREMENT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in msg/InputSpeedMeasurement in the package microstrain_inertial_msgs.
typedef struct microstrain_inertial_msgs__msg__InputSpeedMeasurement
{
  /// GPS time of week when speed was sampled
  float gps_tow;
  /// Estimated speed along vehicle's x-axis (may be positive or negative) (m/s)
  float speed;
  /// Estimated uncertainty in the speed measurement (1-sigma value) (m/s)
  float speed_uncertainty;
} microstrain_inertial_msgs__msg__InputSpeedMeasurement;

// Struct for a sequence of microstrain_inertial_msgs__msg__InputSpeedMeasurement.
typedef struct microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence
{
  microstrain_inertial_msgs__msg__InputSpeedMeasurement * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__INPUT_SPEED_MEASUREMENT__STRUCT_H_
