// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from microstrain_inertial_msgs:msg/RTKStatus.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__RTK_STATUS__STRUCT_H_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__RTK_STATUS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MODEM_STATE_OFF'.
enum
{
  microstrain_inertial_msgs__msg__RTKStatus__MODEM_STATE_OFF = 0
};

/// Constant 'MODEM_STATE_NO_NETWORK'.
enum
{
  microstrain_inertial_msgs__msg__RTKStatus__MODEM_STATE_NO_NETWORK = 1
};

/// Constant 'MODEM_STATE_NETWORK_CONNECTED'.
enum
{
  microstrain_inertial_msgs__msg__RTKStatus__MODEM_STATE_NETWORK_CONNECTED = 2
};

/// Constant 'MODEM_STATE_CONFIGURING_DATA_CONTEXT'.
enum
{
  microstrain_inertial_msgs__msg__RTKStatus__MODEM_STATE_CONFIGURING_DATA_CONTEXT = 3
};

/// Constant 'MODEM_STATE_ACTIVATING_DATA_CONTEXT'.
enum
{
  microstrain_inertial_msgs__msg__RTKStatus__MODEM_STATE_ACTIVATING_DATA_CONTEXT = 4
};

/// Constant 'MODEM_STATE_CONFIGURING_SOCKET'.
enum
{
  microstrain_inertial_msgs__msg__RTKStatus__MODEM_STATE_CONFIGURING_SOCKET = 5
};

/// Constant 'MODEM_STATE_WAITING_ON_SERVER_HANDSHAKE'.
enum
{
  microstrain_inertial_msgs__msg__RTKStatus__MODEM_STATE_WAITING_ON_SERVER_HANDSHAKE = 6
};

/// Constant 'MODEM_STATE_CONNECTED_AND_IDLE'.
enum
{
  microstrain_inertial_msgs__msg__RTKStatus__MODEM_STATE_CONNECTED_AND_IDLE = 7
};

/// Constant 'MODEM_STATE_CONNECTED_AND_STREAMING'.
enum
{
  microstrain_inertial_msgs__msg__RTKStatus__MODEM_STATE_CONNECTED_AND_STREAMING = 8
};

/// Constant 'CONNECTION_TYPE_NO_CONNECTION'.
/**
  * Possible values for dongle_connection_type
 */
enum
{
  microstrain_inertial_msgs__msg__RTKStatus__CONNECTION_TYPE_NO_CONNECTION = 0
};

/// Constant 'CONNECTION_TYPE_CONNECTION_2G'.
enum
{
  microstrain_inertial_msgs__msg__RTKStatus__CONNECTION_TYPE_CONNECTION_2G = 2
};

/// Constant 'CONNECTION_TYPE_CONNECTION_3G'.
enum
{
  microstrain_inertial_msgs__msg__RTKStatus__CONNECTION_TYPE_CONNECTION_3G = 3
};

/// Constant 'CONNECTION_TYPE_CONNECTION_4G'.
enum
{
  microstrain_inertial_msgs__msg__RTKStatus__CONNECTION_TYPE_CONNECTION_4G = 4
};

/// Constant 'CONNECTION_TYPE_CONNECTION_5G'.
enum
{
  microstrain_inertial_msgs__msg__RTKStatus__CONNECTION_TYPE_CONNECTION_5G = 5
};

/// Struct defined in msg/RTKStatus in the package microstrain_inertial_msgs.
/**
  * Possible values for dongle_modem_state
 */
typedef struct microstrain_inertial_msgs__msg__RTKStatus
{
  double gps_tow;
  uint16_t gps_week;
  uint16_t epoch_status;
  uint8_t dongle_version;
  /// Use in conjunction with MODEM_STATE_* values
  uint8_t dongle_modem_state;
  /// Use in conjunction with CONNECTION_TYPE_* values
  uint8_t dongle_connection_type;
  /// RSSI values are negative
  int8_t dongle_rssi;
  uint8_t dongle_signal_quality;
  uint8_t dongle_tower_change_indicator;
  bool dongle_nmea_timeout;
  bool dongle_server_timeout;
  bool dongle_rtcm_timeout;
  bool dongle_out_of_range;
  bool dongle_corrections_unavailable;
  float gps_correction_latency;
  float glonass_correction_latency;
  float galileo_correction_latency;
  float beidou_correction_latency;
  /// Raw status flags value
  uint32_t raw_status_flags;
} microstrain_inertial_msgs__msg__RTKStatus;

// Struct for a sequence of microstrain_inertial_msgs__msg__RTKStatus.
typedef struct microstrain_inertial_msgs__msg__RTKStatus__Sequence
{
  microstrain_inertial_msgs__msg__RTKStatus * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} microstrain_inertial_msgs__msg__RTKStatus__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__RTK_STATUS__STRUCT_H_
