// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/RTKStatus.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__RTK_STATUS__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__RTK_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__RTKStatus __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__RTKStatus __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RTKStatus_
{
  using Type = RTKStatus_<ContainerAllocator>;

  explicit RTKStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0;
      this->gps_week = 0;
      this->epoch_status = 0;
      this->dongle_version = 0;
      this->dongle_modem_state = 0;
      this->dongle_connection_type = 0;
      this->dongle_rssi = 0;
      this->dongle_signal_quality = 0;
      this->dongle_tower_change_indicator = 0;
      this->dongle_nmea_timeout = false;
      this->dongle_server_timeout = false;
      this->dongle_rtcm_timeout = false;
      this->dongle_out_of_range = false;
      this->dongle_corrections_unavailable = false;
      this->gps_correction_latency = 0.0f;
      this->glonass_correction_latency = 0.0f;
      this->galileo_correction_latency = 0.0f;
      this->beidou_correction_latency = 0.0f;
      this->raw_status_flags = 0ul;
    }
  }

  explicit RTKStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0;
      this->gps_week = 0;
      this->epoch_status = 0;
      this->dongle_version = 0;
      this->dongle_modem_state = 0;
      this->dongle_connection_type = 0;
      this->dongle_rssi = 0;
      this->dongle_signal_quality = 0;
      this->dongle_tower_change_indicator = 0;
      this->dongle_nmea_timeout = false;
      this->dongle_server_timeout = false;
      this->dongle_rtcm_timeout = false;
      this->dongle_out_of_range = false;
      this->dongle_corrections_unavailable = false;
      this->gps_correction_latency = 0.0f;
      this->glonass_correction_latency = 0.0f;
      this->galileo_correction_latency = 0.0f;
      this->beidou_correction_latency = 0.0f;
      this->raw_status_flags = 0ul;
    }
  }

  // field types and members
  using _gps_tow_type =
    double;
  _gps_tow_type gps_tow;
  using _gps_week_type =
    uint16_t;
  _gps_week_type gps_week;
  using _epoch_status_type =
    uint16_t;
  _epoch_status_type epoch_status;
  using _dongle_version_type =
    uint8_t;
  _dongle_version_type dongle_version;
  using _dongle_modem_state_type =
    uint8_t;
  _dongle_modem_state_type dongle_modem_state;
  using _dongle_connection_type_type =
    uint8_t;
  _dongle_connection_type_type dongle_connection_type;
  using _dongle_rssi_type =
    int8_t;
  _dongle_rssi_type dongle_rssi;
  using _dongle_signal_quality_type =
    uint8_t;
  _dongle_signal_quality_type dongle_signal_quality;
  using _dongle_tower_change_indicator_type =
    uint8_t;
  _dongle_tower_change_indicator_type dongle_tower_change_indicator;
  using _dongle_nmea_timeout_type =
    bool;
  _dongle_nmea_timeout_type dongle_nmea_timeout;
  using _dongle_server_timeout_type =
    bool;
  _dongle_server_timeout_type dongle_server_timeout;
  using _dongle_rtcm_timeout_type =
    bool;
  _dongle_rtcm_timeout_type dongle_rtcm_timeout;
  using _dongle_out_of_range_type =
    bool;
  _dongle_out_of_range_type dongle_out_of_range;
  using _dongle_corrections_unavailable_type =
    bool;
  _dongle_corrections_unavailable_type dongle_corrections_unavailable;
  using _gps_correction_latency_type =
    float;
  _gps_correction_latency_type gps_correction_latency;
  using _glonass_correction_latency_type =
    float;
  _glonass_correction_latency_type glonass_correction_latency;
  using _galileo_correction_latency_type =
    float;
  _galileo_correction_latency_type galileo_correction_latency;
  using _beidou_correction_latency_type =
    float;
  _beidou_correction_latency_type beidou_correction_latency;
  using _raw_status_flags_type =
    uint32_t;
  _raw_status_flags_type raw_status_flags;

  // setters for named parameter idiom
  Type & set__gps_tow(
    const double & _arg)
  {
    this->gps_tow = _arg;
    return *this;
  }
  Type & set__gps_week(
    const uint16_t & _arg)
  {
    this->gps_week = _arg;
    return *this;
  }
  Type & set__epoch_status(
    const uint16_t & _arg)
  {
    this->epoch_status = _arg;
    return *this;
  }
  Type & set__dongle_version(
    const uint8_t & _arg)
  {
    this->dongle_version = _arg;
    return *this;
  }
  Type & set__dongle_modem_state(
    const uint8_t & _arg)
  {
    this->dongle_modem_state = _arg;
    return *this;
  }
  Type & set__dongle_connection_type(
    const uint8_t & _arg)
  {
    this->dongle_connection_type = _arg;
    return *this;
  }
  Type & set__dongle_rssi(
    const int8_t & _arg)
  {
    this->dongle_rssi = _arg;
    return *this;
  }
  Type & set__dongle_signal_quality(
    const uint8_t & _arg)
  {
    this->dongle_signal_quality = _arg;
    return *this;
  }
  Type & set__dongle_tower_change_indicator(
    const uint8_t & _arg)
  {
    this->dongle_tower_change_indicator = _arg;
    return *this;
  }
  Type & set__dongle_nmea_timeout(
    const bool & _arg)
  {
    this->dongle_nmea_timeout = _arg;
    return *this;
  }
  Type & set__dongle_server_timeout(
    const bool & _arg)
  {
    this->dongle_server_timeout = _arg;
    return *this;
  }
  Type & set__dongle_rtcm_timeout(
    const bool & _arg)
  {
    this->dongle_rtcm_timeout = _arg;
    return *this;
  }
  Type & set__dongle_out_of_range(
    const bool & _arg)
  {
    this->dongle_out_of_range = _arg;
    return *this;
  }
  Type & set__dongle_corrections_unavailable(
    const bool & _arg)
  {
    this->dongle_corrections_unavailable = _arg;
    return *this;
  }
  Type & set__gps_correction_latency(
    const float & _arg)
  {
    this->gps_correction_latency = _arg;
    return *this;
  }
  Type & set__glonass_correction_latency(
    const float & _arg)
  {
    this->glonass_correction_latency = _arg;
    return *this;
  }
  Type & set__galileo_correction_latency(
    const float & _arg)
  {
    this->galileo_correction_latency = _arg;
    return *this;
  }
  Type & set__beidou_correction_latency(
    const float & _arg)
  {
    this->beidou_correction_latency = _arg;
    return *this;
  }
  Type & set__raw_status_flags(
    const uint32_t & _arg)
  {
    this->raw_status_flags = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t MODEM_STATE_OFF =
    0u;
  static constexpr uint8_t MODEM_STATE_NO_NETWORK =
    1u;
  static constexpr uint8_t MODEM_STATE_NETWORK_CONNECTED =
    2u;
  static constexpr uint8_t MODEM_STATE_CONFIGURING_DATA_CONTEXT =
    3u;
  static constexpr uint8_t MODEM_STATE_ACTIVATING_DATA_CONTEXT =
    4u;
  static constexpr uint8_t MODEM_STATE_CONFIGURING_SOCKET =
    5u;
  static constexpr uint8_t MODEM_STATE_WAITING_ON_SERVER_HANDSHAKE =
    6u;
  static constexpr uint8_t MODEM_STATE_CONNECTED_AND_IDLE =
    7u;
  static constexpr uint8_t MODEM_STATE_CONNECTED_AND_STREAMING =
    8u;
  static constexpr uint8_t CONNECTION_TYPE_NO_CONNECTION =
    0u;
  static constexpr uint8_t CONNECTION_TYPE_CONNECTION_2G =
    2u;
  static constexpr uint8_t CONNECTION_TYPE_CONNECTION_3G =
    3u;
  static constexpr uint8_t CONNECTION_TYPE_CONNECTION_4G =
    4u;
  static constexpr uint8_t CONNECTION_TYPE_CONNECTION_5G =
    5u;

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::RTKStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::RTKStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::RTKStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::RTKStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::RTKStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::RTKStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::RTKStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::RTKStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::RTKStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::RTKStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__RTKStatus
    std::shared_ptr<microstrain_inertial_msgs::msg::RTKStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__RTKStatus
    std::shared_ptr<microstrain_inertial_msgs::msg::RTKStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RTKStatus_ & other) const
  {
    if (this->gps_tow != other.gps_tow) {
      return false;
    }
    if (this->gps_week != other.gps_week) {
      return false;
    }
    if (this->epoch_status != other.epoch_status) {
      return false;
    }
    if (this->dongle_version != other.dongle_version) {
      return false;
    }
    if (this->dongle_modem_state != other.dongle_modem_state) {
      return false;
    }
    if (this->dongle_connection_type != other.dongle_connection_type) {
      return false;
    }
    if (this->dongle_rssi != other.dongle_rssi) {
      return false;
    }
    if (this->dongle_signal_quality != other.dongle_signal_quality) {
      return false;
    }
    if (this->dongle_tower_change_indicator != other.dongle_tower_change_indicator) {
      return false;
    }
    if (this->dongle_nmea_timeout != other.dongle_nmea_timeout) {
      return false;
    }
    if (this->dongle_server_timeout != other.dongle_server_timeout) {
      return false;
    }
    if (this->dongle_rtcm_timeout != other.dongle_rtcm_timeout) {
      return false;
    }
    if (this->dongle_out_of_range != other.dongle_out_of_range) {
      return false;
    }
    if (this->dongle_corrections_unavailable != other.dongle_corrections_unavailable) {
      return false;
    }
    if (this->gps_correction_latency != other.gps_correction_latency) {
      return false;
    }
    if (this->glonass_correction_latency != other.glonass_correction_latency) {
      return false;
    }
    if (this->galileo_correction_latency != other.galileo_correction_latency) {
      return false;
    }
    if (this->beidou_correction_latency != other.beidou_correction_latency) {
      return false;
    }
    if (this->raw_status_flags != other.raw_status_flags) {
      return false;
    }
    return true;
  }
  bool operator!=(const RTKStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RTKStatus_

// alias to use template instance with default allocator
using RTKStatus =
  microstrain_inertial_msgs::msg::RTKStatus_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RTKStatus_<ContainerAllocator>::MODEM_STATE_OFF;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RTKStatus_<ContainerAllocator>::MODEM_STATE_NO_NETWORK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RTKStatus_<ContainerAllocator>::MODEM_STATE_NETWORK_CONNECTED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RTKStatus_<ContainerAllocator>::MODEM_STATE_CONFIGURING_DATA_CONTEXT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RTKStatus_<ContainerAllocator>::MODEM_STATE_ACTIVATING_DATA_CONTEXT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RTKStatus_<ContainerAllocator>::MODEM_STATE_CONFIGURING_SOCKET;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RTKStatus_<ContainerAllocator>::MODEM_STATE_WAITING_ON_SERVER_HANDSHAKE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RTKStatus_<ContainerAllocator>::MODEM_STATE_CONNECTED_AND_IDLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RTKStatus_<ContainerAllocator>::MODEM_STATE_CONNECTED_AND_STREAMING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RTKStatus_<ContainerAllocator>::CONNECTION_TYPE_NO_CONNECTION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RTKStatus_<ContainerAllocator>::CONNECTION_TYPE_CONNECTION_2G;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RTKStatus_<ContainerAllocator>::CONNECTION_TYPE_CONNECTION_3G;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RTKStatus_<ContainerAllocator>::CONNECTION_TYPE_CONNECTION_4G;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RTKStatus_<ContainerAllocator>::CONNECTION_TYPE_CONNECTION_5G;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__RTK_STATUS__STRUCT_HPP_
