// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/RTKStatusV1.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__RTK_STATUS_V1__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__RTK_STATUS_V1__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__RTKStatusV1 __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__RTKStatusV1 __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RTKStatusV1_
{
  using Type = RTKStatusV1_<ContainerAllocator>;

  explicit RTKStatusV1_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0;
      this->gps_week = 0;
      this->epoch_status = 0;
      this->dongle_version = 0;
      this->dongle_controller_state = 0;
      this->dongle_platform_state = 0;
      this->dongle_controller_status = 0;
      this->dongle_platform_status = 0;
      this->dongle_reset_reason = 0;
      this->dongle_signal_quality = 0;
      this->gps_correction_latency = 0.0f;
      this->glonass_correction_latency = 0.0f;
      this->galileo_correction_latency = 0.0f;
      this->beidou_correction_latency = 0.0f;
      this->raw_status_flags = 0ul;
    }
  }

  explicit RTKStatusV1_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0;
      this->gps_week = 0;
      this->epoch_status = 0;
      this->dongle_version = 0;
      this->dongle_controller_state = 0;
      this->dongle_platform_state = 0;
      this->dongle_controller_status = 0;
      this->dongle_platform_status = 0;
      this->dongle_reset_reason = 0;
      this->dongle_signal_quality = 0;
      this->gps_correction_latency = 0.0f;
      this->glonass_correction_latency = 0.0f;
      this->galileo_correction_latency = 0.0f;
      this->beidou_correction_latency = 0.0f;
      this->raw_status_flags = 0ul;
    }
  }

  // field types and members
  using _gps_tow_type =
    double;
  _gps_tow_type gps_tow;
  using _gps_week_type =
    uint16_t;
  _gps_week_type gps_week;
  using _epoch_status_type =
    uint16_t;
  _epoch_status_type epoch_status;
  using _dongle_version_type =
    uint8_t;
  _dongle_version_type dongle_version;
  using _dongle_controller_state_type =
    uint8_t;
  _dongle_controller_state_type dongle_controller_state;
  using _dongle_platform_state_type =
    uint8_t;
  _dongle_platform_state_type dongle_platform_state;
  using _dongle_controller_status_type =
    uint8_t;
  _dongle_controller_status_type dongle_controller_status;
  using _dongle_platform_status_type =
    uint8_t;
  _dongle_platform_status_type dongle_platform_status;
  using _dongle_reset_reason_type =
    uint8_t;
  _dongle_reset_reason_type dongle_reset_reason;
  using _dongle_signal_quality_type =
    uint8_t;
  _dongle_signal_quality_type dongle_signal_quality;
  using _gps_correction_latency_type =
    float;
  _gps_correction_latency_type gps_correction_latency;
  using _glonass_correction_latency_type =
    float;
  _glonass_correction_latency_type glonass_correction_latency;
  using _galileo_correction_latency_type =
    float;
  _galileo_correction_latency_type galileo_correction_latency;
  using _beidou_correction_latency_type =
    float;
  _beidou_correction_latency_type beidou_correction_latency;
  using _raw_status_flags_type =
    uint32_t;
  _raw_status_flags_type raw_status_flags;

  // setters for named parameter idiom
  Type & set__gps_tow(
    const double & _arg)
  {
    this->gps_tow = _arg;
    return *this;
  }
  Type & set__gps_week(
    const uint16_t & _arg)
  {
    this->gps_week = _arg;
    return *this;
  }
  Type & set__epoch_status(
    const uint16_t & _arg)
  {
    this->epoch_status = _arg;
    return *this;
  }
  Type & set__dongle_version(
    const uint8_t & _arg)
  {
    this->dongle_version = _arg;
    return *this;
  }
  Type & set__dongle_controller_state(
    const uint8_t & _arg)
  {
    this->dongle_controller_state = _arg;
    return *this;
  }
  Type & set__dongle_platform_state(
    const uint8_t & _arg)
  {
    this->dongle_platform_state = _arg;
    return *this;
  }
  Type & set__dongle_controller_status(
    const uint8_t & _arg)
  {
    this->dongle_controller_status = _arg;
    return *this;
  }
  Type & set__dongle_platform_status(
    const uint8_t & _arg)
  {
    this->dongle_platform_status = _arg;
    return *this;
  }
  Type & set__dongle_reset_reason(
    const uint8_t & _arg)
  {
    this->dongle_reset_reason = _arg;
    return *this;
  }
  Type & set__dongle_signal_quality(
    const uint8_t & _arg)
  {
    this->dongle_signal_quality = _arg;
    return *this;
  }
  Type & set__gps_correction_latency(
    const float & _arg)
  {
    this->gps_correction_latency = _arg;
    return *this;
  }
  Type & set__glonass_correction_latency(
    const float & _arg)
  {
    this->glonass_correction_latency = _arg;
    return *this;
  }
  Type & set__galileo_correction_latency(
    const float & _arg)
  {
    this->galileo_correction_latency = _arg;
    return *this;
  }
  Type & set__beidou_correction_latency(
    const float & _arg)
  {
    this->beidou_correction_latency = _arg;
    return *this;
  }
  Type & set__raw_status_flags(
    const uint32_t & _arg)
  {
    this->raw_status_flags = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::RTKStatusV1_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::RTKStatusV1_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::RTKStatusV1_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::RTKStatusV1_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::RTKStatusV1_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::RTKStatusV1_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::RTKStatusV1_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::RTKStatusV1_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::RTKStatusV1_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::RTKStatusV1_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__RTKStatusV1
    std::shared_ptr<microstrain_inertial_msgs::msg::RTKStatusV1_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__RTKStatusV1
    std::shared_ptr<microstrain_inertial_msgs::msg::RTKStatusV1_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RTKStatusV1_ & other) const
  {
    if (this->gps_tow != other.gps_tow) {
      return false;
    }
    if (this->gps_week != other.gps_week) {
      return false;
    }
    if (this->epoch_status != other.epoch_status) {
      return false;
    }
    if (this->dongle_version != other.dongle_version) {
      return false;
    }
    if (this->dongle_controller_state != other.dongle_controller_state) {
      return false;
    }
    if (this->dongle_platform_state != other.dongle_platform_state) {
      return false;
    }
    if (this->dongle_controller_status != other.dongle_controller_status) {
      return false;
    }
    if (this->dongle_platform_status != other.dongle_platform_status) {
      return false;
    }
    if (this->dongle_reset_reason != other.dongle_reset_reason) {
      return false;
    }
    if (this->dongle_signal_quality != other.dongle_signal_quality) {
      return false;
    }
    if (this->gps_correction_latency != other.gps_correction_latency) {
      return false;
    }
    if (this->glonass_correction_latency != other.glonass_correction_latency) {
      return false;
    }
    if (this->galileo_correction_latency != other.galileo_correction_latency) {
      return false;
    }
    if (this->beidou_correction_latency != other.beidou_correction_latency) {
      return false;
    }
    if (this->raw_status_flags != other.raw_status_flags) {
      return false;
    }
    return true;
  }
  bool operator!=(const RTKStatusV1_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RTKStatusV1_

// alias to use template instance with default allocator
using RTKStatusV1 =
  microstrain_inertial_msgs::msg::RTKStatusV1_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__RTK_STATUS_V1__STRUCT_HPP_
