// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:msg/RTKStatusV1.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__RTK_STATUS_V1__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__RTK_STATUS_V1__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "microstrain_inertial_msgs/msg/detail/rtk_status_v1__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace microstrain_inertial_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RTKStatusV1 & msg,
  std::ostream & out)
{
  out << "{";
  // member: gps_tow
  {
    out << "gps_tow: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_tow, out);
    out << ", ";
  }

  // member: gps_week
  {
    out << "gps_week: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_week, out);
    out << ", ";
  }

  // member: epoch_status
  {
    out << "epoch_status: ";
    rosidl_generator_traits::value_to_yaml(msg.epoch_status, out);
    out << ", ";
  }

  // member: dongle_version
  {
    out << "dongle_version: ";
    rosidl_generator_traits::value_to_yaml(msg.dongle_version, out);
    out << ", ";
  }

  // member: dongle_controller_state
  {
    out << "dongle_controller_state: ";
    rosidl_generator_traits::value_to_yaml(msg.dongle_controller_state, out);
    out << ", ";
  }

  // member: dongle_platform_state
  {
    out << "dongle_platform_state: ";
    rosidl_generator_traits::value_to_yaml(msg.dongle_platform_state, out);
    out << ", ";
  }

  // member: dongle_controller_status
  {
    out << "dongle_controller_status: ";
    rosidl_generator_traits::value_to_yaml(msg.dongle_controller_status, out);
    out << ", ";
  }

  // member: dongle_platform_status
  {
    out << "dongle_platform_status: ";
    rosidl_generator_traits::value_to_yaml(msg.dongle_platform_status, out);
    out << ", ";
  }

  // member: dongle_reset_reason
  {
    out << "dongle_reset_reason: ";
    rosidl_generator_traits::value_to_yaml(msg.dongle_reset_reason, out);
    out << ", ";
  }

  // member: dongle_signal_quality
  {
    out << "dongle_signal_quality: ";
    rosidl_generator_traits::value_to_yaml(msg.dongle_signal_quality, out);
    out << ", ";
  }

  // member: gps_correction_latency
  {
    out << "gps_correction_latency: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_correction_latency, out);
    out << ", ";
  }

  // member: glonass_correction_latency
  {
    out << "glonass_correction_latency: ";
    rosidl_generator_traits::value_to_yaml(msg.glonass_correction_latency, out);
    out << ", ";
  }

  // member: galileo_correction_latency
  {
    out << "galileo_correction_latency: ";
    rosidl_generator_traits::value_to_yaml(msg.galileo_correction_latency, out);
    out << ", ";
  }

  // member: beidou_correction_latency
  {
    out << "beidou_correction_latency: ";
    rosidl_generator_traits::value_to_yaml(msg.beidou_correction_latency, out);
    out << ", ";
  }

  // member: raw_status_flags
  {
    out << "raw_status_flags: ";
    rosidl_generator_traits::value_to_yaml(msg.raw_status_flags, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RTKStatusV1 & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: gps_tow
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_tow: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_tow, out);
    out << "\n";
  }

  // member: gps_week
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_week: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_week, out);
    out << "\n";
  }

  // member: epoch_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "epoch_status: ";
    rosidl_generator_traits::value_to_yaml(msg.epoch_status, out);
    out << "\n";
  }

  // member: dongle_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_version: ";
    rosidl_generator_traits::value_to_yaml(msg.dongle_version, out);
    out << "\n";
  }

  // member: dongle_controller_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_controller_state: ";
    rosidl_generator_traits::value_to_yaml(msg.dongle_controller_state, out);
    out << "\n";
  }

  // member: dongle_platform_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_platform_state: ";
    rosidl_generator_traits::value_to_yaml(msg.dongle_platform_state, out);
    out << "\n";
  }

  // member: dongle_controller_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_controller_status: ";
    rosidl_generator_traits::value_to_yaml(msg.dongle_controller_status, out);
    out << "\n";
  }

  // member: dongle_platform_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_platform_status: ";
    rosidl_generator_traits::value_to_yaml(msg.dongle_platform_status, out);
    out << "\n";
  }

  // member: dongle_reset_reason
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_reset_reason: ";
    rosidl_generator_traits::value_to_yaml(msg.dongle_reset_reason, out);
    out << "\n";
  }

  // member: dongle_signal_quality
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_signal_quality: ";
    rosidl_generator_traits::value_to_yaml(msg.dongle_signal_quality, out);
    out << "\n";
  }

  // member: gps_correction_latency
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_correction_latency: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_correction_latency, out);
    out << "\n";
  }

  // member: glonass_correction_latency
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "glonass_correction_latency: ";
    rosidl_generator_traits::value_to_yaml(msg.glonass_correction_latency, out);
    out << "\n";
  }

  // member: galileo_correction_latency
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "galileo_correction_latency: ";
    rosidl_generator_traits::value_to_yaml(msg.galileo_correction_latency, out);
    out << "\n";
  }

  // member: beidou_correction_latency
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "beidou_correction_latency: ";
    rosidl_generator_traits::value_to_yaml(msg.beidou_correction_latency, out);
    out << "\n";
  }

  // member: raw_status_flags
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "raw_status_flags: ";
    rosidl_generator_traits::value_to_yaml(msg.raw_status_flags, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RTKStatusV1 & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::msg::RTKStatusV1 & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::msg::RTKStatusV1 & msg)
{
  return microstrain_inertial_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::msg::RTKStatusV1>()
{
  return "microstrain_inertial_msgs::msg::RTKStatusV1";
}

template<>
inline const char * name<microstrain_inertial_msgs::msg::RTKStatusV1>()
{
  return "microstrain_inertial_msgs/msg/RTKStatusV1";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::msg::RTKStatusV1>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::msg::RTKStatusV1>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::msg::RTKStatusV1>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__RTK_STATUS_V1__TRAITS_HPP_
