// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from microstrain_inertial_msgs:msg/Status.idl
// generated code does not contain a copyright notice
#include "microstrain_inertial_msgs/msg/detail/status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
microstrain_inertial_msgs__msg__Status__init(microstrain_inertial_msgs__msg__Status * msg)
{
  if (!msg) {
    return false;
  }
  // device_model
  // status_selector
  // status_flags
  // system_state
  // system_timer_ms
  // gps_power_on
  // num_gps_pps_triggers
  // last_gps_pps_trigger_ms
  // imu_stream_enabled
  // gps_stream_enabled
  // filter_stream_enabled
  // imu_dropped_packets
  // gps_dropped_packets
  // filter_dropped_packets
  // com1_port_bytes_written
  // com1_port_bytes_read
  // com1_port_write_overruns
  // com1_port_read_overruns
  // imu_parser_errors
  // imu_message_count
  // imu_last_message_ms
  // gps_parser_errors
  // gps_message_count
  // gps_last_message_ms
  return true;
}

void
microstrain_inertial_msgs__msg__Status__fini(microstrain_inertial_msgs__msg__Status * msg)
{
  if (!msg) {
    return;
  }
  // device_model
  // status_selector
  // status_flags
  // system_state
  // system_timer_ms
  // gps_power_on
  // num_gps_pps_triggers
  // last_gps_pps_trigger_ms
  // imu_stream_enabled
  // gps_stream_enabled
  // filter_stream_enabled
  // imu_dropped_packets
  // gps_dropped_packets
  // filter_dropped_packets
  // com1_port_bytes_written
  // com1_port_bytes_read
  // com1_port_write_overruns
  // com1_port_read_overruns
  // imu_parser_errors
  // imu_message_count
  // imu_last_message_ms
  // gps_parser_errors
  // gps_message_count
  // gps_last_message_ms
}

bool
microstrain_inertial_msgs__msg__Status__are_equal(const microstrain_inertial_msgs__msg__Status * lhs, const microstrain_inertial_msgs__msg__Status * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // device_model
  if (lhs->device_model != rhs->device_model) {
    return false;
  }
  // status_selector
  if (lhs->status_selector != rhs->status_selector) {
    return false;
  }
  // status_flags
  if (lhs->status_flags != rhs->status_flags) {
    return false;
  }
  // system_state
  if (lhs->system_state != rhs->system_state) {
    return false;
  }
  // system_timer_ms
  if (lhs->system_timer_ms != rhs->system_timer_ms) {
    return false;
  }
  // gps_power_on
  if (lhs->gps_power_on != rhs->gps_power_on) {
    return false;
  }
  // num_gps_pps_triggers
  if (lhs->num_gps_pps_triggers != rhs->num_gps_pps_triggers) {
    return false;
  }
  // last_gps_pps_trigger_ms
  if (lhs->last_gps_pps_trigger_ms != rhs->last_gps_pps_trigger_ms) {
    return false;
  }
  // imu_stream_enabled
  if (lhs->imu_stream_enabled != rhs->imu_stream_enabled) {
    return false;
  }
  // gps_stream_enabled
  if (lhs->gps_stream_enabled != rhs->gps_stream_enabled) {
    return false;
  }
  // filter_stream_enabled
  if (lhs->filter_stream_enabled != rhs->filter_stream_enabled) {
    return false;
  }
  // imu_dropped_packets
  if (lhs->imu_dropped_packets != rhs->imu_dropped_packets) {
    return false;
  }
  // gps_dropped_packets
  if (lhs->gps_dropped_packets != rhs->gps_dropped_packets) {
    return false;
  }
  // filter_dropped_packets
  if (lhs->filter_dropped_packets != rhs->filter_dropped_packets) {
    return false;
  }
  // com1_port_bytes_written
  if (lhs->com1_port_bytes_written != rhs->com1_port_bytes_written) {
    return false;
  }
  // com1_port_bytes_read
  if (lhs->com1_port_bytes_read != rhs->com1_port_bytes_read) {
    return false;
  }
  // com1_port_write_overruns
  if (lhs->com1_port_write_overruns != rhs->com1_port_write_overruns) {
    return false;
  }
  // com1_port_read_overruns
  if (lhs->com1_port_read_overruns != rhs->com1_port_read_overruns) {
    return false;
  }
  // imu_parser_errors
  if (lhs->imu_parser_errors != rhs->imu_parser_errors) {
    return false;
  }
  // imu_message_count
  if (lhs->imu_message_count != rhs->imu_message_count) {
    return false;
  }
  // imu_last_message_ms
  if (lhs->imu_last_message_ms != rhs->imu_last_message_ms) {
    return false;
  }
  // gps_parser_errors
  if (lhs->gps_parser_errors != rhs->gps_parser_errors) {
    return false;
  }
  // gps_message_count
  if (lhs->gps_message_count != rhs->gps_message_count) {
    return false;
  }
  // gps_last_message_ms
  if (lhs->gps_last_message_ms != rhs->gps_last_message_ms) {
    return false;
  }
  return true;
}

bool
microstrain_inertial_msgs__msg__Status__copy(
  const microstrain_inertial_msgs__msg__Status * input,
  microstrain_inertial_msgs__msg__Status * output)
{
  if (!input || !output) {
    return false;
  }
  // device_model
  output->device_model = input->device_model;
  // status_selector
  output->status_selector = input->status_selector;
  // status_flags
  output->status_flags = input->status_flags;
  // system_state
  output->system_state = input->system_state;
  // system_timer_ms
  output->system_timer_ms = input->system_timer_ms;
  // gps_power_on
  output->gps_power_on = input->gps_power_on;
  // num_gps_pps_triggers
  output->num_gps_pps_triggers = input->num_gps_pps_triggers;
  // last_gps_pps_trigger_ms
  output->last_gps_pps_trigger_ms = input->last_gps_pps_trigger_ms;
  // imu_stream_enabled
  output->imu_stream_enabled = input->imu_stream_enabled;
  // gps_stream_enabled
  output->gps_stream_enabled = input->gps_stream_enabled;
  // filter_stream_enabled
  output->filter_stream_enabled = input->filter_stream_enabled;
  // imu_dropped_packets
  output->imu_dropped_packets = input->imu_dropped_packets;
  // gps_dropped_packets
  output->gps_dropped_packets = input->gps_dropped_packets;
  // filter_dropped_packets
  output->filter_dropped_packets = input->filter_dropped_packets;
  // com1_port_bytes_written
  output->com1_port_bytes_written = input->com1_port_bytes_written;
  // com1_port_bytes_read
  output->com1_port_bytes_read = input->com1_port_bytes_read;
  // com1_port_write_overruns
  output->com1_port_write_overruns = input->com1_port_write_overruns;
  // com1_port_read_overruns
  output->com1_port_read_overruns = input->com1_port_read_overruns;
  // imu_parser_errors
  output->imu_parser_errors = input->imu_parser_errors;
  // imu_message_count
  output->imu_message_count = input->imu_message_count;
  // imu_last_message_ms
  output->imu_last_message_ms = input->imu_last_message_ms;
  // gps_parser_errors
  output->gps_parser_errors = input->gps_parser_errors;
  // gps_message_count
  output->gps_message_count = input->gps_message_count;
  // gps_last_message_ms
  output->gps_last_message_ms = input->gps_last_message_ms;
  return true;
}

microstrain_inertial_msgs__msg__Status *
microstrain_inertial_msgs__msg__Status__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__Status * msg = (microstrain_inertial_msgs__msg__Status *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__Status), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(microstrain_inertial_msgs__msg__Status));
  bool success = microstrain_inertial_msgs__msg__Status__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
microstrain_inertial_msgs__msg__Status__destroy(microstrain_inertial_msgs__msg__Status * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    microstrain_inertial_msgs__msg__Status__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
microstrain_inertial_msgs__msg__Status__Sequence__init(microstrain_inertial_msgs__msg__Status__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__Status * data = NULL;

  if (size) {
    data = (microstrain_inertial_msgs__msg__Status *)allocator.zero_allocate(size, sizeof(microstrain_inertial_msgs__msg__Status), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = microstrain_inertial_msgs__msg__Status__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        microstrain_inertial_msgs__msg__Status__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
microstrain_inertial_msgs__msg__Status__Sequence__fini(microstrain_inertial_msgs__msg__Status__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      microstrain_inertial_msgs__msg__Status__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

microstrain_inertial_msgs__msg__Status__Sequence *
microstrain_inertial_msgs__msg__Status__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__Status__Sequence * array = (microstrain_inertial_msgs__msg__Status__Sequence *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__Status__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = microstrain_inertial_msgs__msg__Status__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
microstrain_inertial_msgs__msg__Status__Sequence__destroy(microstrain_inertial_msgs__msg__Status__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    microstrain_inertial_msgs__msg__Status__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
microstrain_inertial_msgs__msg__Status__Sequence__are_equal(const microstrain_inertial_msgs__msg__Status__Sequence * lhs, const microstrain_inertial_msgs__msg__Status__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!microstrain_inertial_msgs__msg__Status__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
microstrain_inertial_msgs__msg__Status__Sequence__copy(
  const microstrain_inertial_msgs__msg__Status__Sequence * input,
  microstrain_inertial_msgs__msg__Status__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(microstrain_inertial_msgs__msg__Status);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    microstrain_inertial_msgs__msg__Status * data =
      (microstrain_inertial_msgs__msg__Status *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!microstrain_inertial_msgs__msg__Status__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          microstrain_inertial_msgs__msg__Status__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!microstrain_inertial_msgs__msg__Status__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
