// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from microstrain_inertial_msgs:msg/Status.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__STATUS__STRUCT_H_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__STATUS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in msg/Status in the package microstrain_inertial_msgs.
typedef struct microstrain_inertial_msgs__msg__Status
{
  uint16_t device_model;
  uint8_t status_selector;
  uint32_t status_flags;
  uint16_t system_state;
  uint32_t system_timer_ms;
  uint8_t gps_power_on;
  uint32_t num_gps_pps_triggers;
  uint32_t last_gps_pps_trigger_ms;
  uint8_t imu_stream_enabled;
  uint8_t gps_stream_enabled;
  uint8_t filter_stream_enabled;
  uint32_t imu_dropped_packets;
  uint32_t gps_dropped_packets;
  uint32_t filter_dropped_packets;
  uint32_t com1_port_bytes_written;
  uint32_t com1_port_bytes_read;
  uint32_t com1_port_write_overruns;
  uint32_t com1_port_read_overruns;
  uint32_t imu_parser_errors;
  uint32_t imu_message_count;
  uint32_t imu_last_message_ms;
  uint32_t gps_parser_errors;
  uint32_t gps_message_count;
  uint32_t gps_last_message_ms;
} microstrain_inertial_msgs__msg__Status;

// Struct for a sequence of microstrain_inertial_msgs__msg__Status.
typedef struct microstrain_inertial_msgs__msg__Status__Sequence
{
  microstrain_inertial_msgs__msg__Status * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} microstrain_inertial_msgs__msg__Status__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__STATUS__STRUCT_H_
