// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/Status.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__STATUS__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__Status __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__Status __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Status_
{
  using Type = Status_<ContainerAllocator>;

  explicit Status_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->device_model = 0;
      this->status_selector = 0;
      this->status_flags = 0ul;
      this->system_state = 0;
      this->system_timer_ms = 0ul;
      this->gps_power_on = 0;
      this->num_gps_pps_triggers = 0ul;
      this->last_gps_pps_trigger_ms = 0ul;
      this->imu_stream_enabled = 0;
      this->gps_stream_enabled = 0;
      this->filter_stream_enabled = 0;
      this->imu_dropped_packets = 0ul;
      this->gps_dropped_packets = 0ul;
      this->filter_dropped_packets = 0ul;
      this->com1_port_bytes_written = 0ul;
      this->com1_port_bytes_read = 0ul;
      this->com1_port_write_overruns = 0ul;
      this->com1_port_read_overruns = 0ul;
      this->imu_parser_errors = 0ul;
      this->imu_message_count = 0ul;
      this->imu_last_message_ms = 0ul;
      this->gps_parser_errors = 0ul;
      this->gps_message_count = 0ul;
      this->gps_last_message_ms = 0ul;
    }
  }

  explicit Status_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->device_model = 0;
      this->status_selector = 0;
      this->status_flags = 0ul;
      this->system_state = 0;
      this->system_timer_ms = 0ul;
      this->gps_power_on = 0;
      this->num_gps_pps_triggers = 0ul;
      this->last_gps_pps_trigger_ms = 0ul;
      this->imu_stream_enabled = 0;
      this->gps_stream_enabled = 0;
      this->filter_stream_enabled = 0;
      this->imu_dropped_packets = 0ul;
      this->gps_dropped_packets = 0ul;
      this->filter_dropped_packets = 0ul;
      this->com1_port_bytes_written = 0ul;
      this->com1_port_bytes_read = 0ul;
      this->com1_port_write_overruns = 0ul;
      this->com1_port_read_overruns = 0ul;
      this->imu_parser_errors = 0ul;
      this->imu_message_count = 0ul;
      this->imu_last_message_ms = 0ul;
      this->gps_parser_errors = 0ul;
      this->gps_message_count = 0ul;
      this->gps_last_message_ms = 0ul;
    }
  }

  // field types and members
  using _device_model_type =
    uint16_t;
  _device_model_type device_model;
  using _status_selector_type =
    uint8_t;
  _status_selector_type status_selector;
  using _status_flags_type =
    uint32_t;
  _status_flags_type status_flags;
  using _system_state_type =
    uint16_t;
  _system_state_type system_state;
  using _system_timer_ms_type =
    uint32_t;
  _system_timer_ms_type system_timer_ms;
  using _gps_power_on_type =
    uint8_t;
  _gps_power_on_type gps_power_on;
  using _num_gps_pps_triggers_type =
    uint32_t;
  _num_gps_pps_triggers_type num_gps_pps_triggers;
  using _last_gps_pps_trigger_ms_type =
    uint32_t;
  _last_gps_pps_trigger_ms_type last_gps_pps_trigger_ms;
  using _imu_stream_enabled_type =
    uint8_t;
  _imu_stream_enabled_type imu_stream_enabled;
  using _gps_stream_enabled_type =
    uint8_t;
  _gps_stream_enabled_type gps_stream_enabled;
  using _filter_stream_enabled_type =
    uint8_t;
  _filter_stream_enabled_type filter_stream_enabled;
  using _imu_dropped_packets_type =
    uint32_t;
  _imu_dropped_packets_type imu_dropped_packets;
  using _gps_dropped_packets_type =
    uint32_t;
  _gps_dropped_packets_type gps_dropped_packets;
  using _filter_dropped_packets_type =
    uint32_t;
  _filter_dropped_packets_type filter_dropped_packets;
  using _com1_port_bytes_written_type =
    uint32_t;
  _com1_port_bytes_written_type com1_port_bytes_written;
  using _com1_port_bytes_read_type =
    uint32_t;
  _com1_port_bytes_read_type com1_port_bytes_read;
  using _com1_port_write_overruns_type =
    uint32_t;
  _com1_port_write_overruns_type com1_port_write_overruns;
  using _com1_port_read_overruns_type =
    uint32_t;
  _com1_port_read_overruns_type com1_port_read_overruns;
  using _imu_parser_errors_type =
    uint32_t;
  _imu_parser_errors_type imu_parser_errors;
  using _imu_message_count_type =
    uint32_t;
  _imu_message_count_type imu_message_count;
  using _imu_last_message_ms_type =
    uint32_t;
  _imu_last_message_ms_type imu_last_message_ms;
  using _gps_parser_errors_type =
    uint32_t;
  _gps_parser_errors_type gps_parser_errors;
  using _gps_message_count_type =
    uint32_t;
  _gps_message_count_type gps_message_count;
  using _gps_last_message_ms_type =
    uint32_t;
  _gps_last_message_ms_type gps_last_message_ms;

  // setters for named parameter idiom
  Type & set__device_model(
    const uint16_t & _arg)
  {
    this->device_model = _arg;
    return *this;
  }
  Type & set__status_selector(
    const uint8_t & _arg)
  {
    this->status_selector = _arg;
    return *this;
  }
  Type & set__status_flags(
    const uint32_t & _arg)
  {
    this->status_flags = _arg;
    return *this;
  }
  Type & set__system_state(
    const uint16_t & _arg)
  {
    this->system_state = _arg;
    return *this;
  }
  Type & set__system_timer_ms(
    const uint32_t & _arg)
  {
    this->system_timer_ms = _arg;
    return *this;
  }
  Type & set__gps_power_on(
    const uint8_t & _arg)
  {
    this->gps_power_on = _arg;
    return *this;
  }
  Type & set__num_gps_pps_triggers(
    const uint32_t & _arg)
  {
    this->num_gps_pps_triggers = _arg;
    return *this;
  }
  Type & set__last_gps_pps_trigger_ms(
    const uint32_t & _arg)
  {
    this->last_gps_pps_trigger_ms = _arg;
    return *this;
  }
  Type & set__imu_stream_enabled(
    const uint8_t & _arg)
  {
    this->imu_stream_enabled = _arg;
    return *this;
  }
  Type & set__gps_stream_enabled(
    const uint8_t & _arg)
  {
    this->gps_stream_enabled = _arg;
    return *this;
  }
  Type & set__filter_stream_enabled(
    const uint8_t & _arg)
  {
    this->filter_stream_enabled = _arg;
    return *this;
  }
  Type & set__imu_dropped_packets(
    const uint32_t & _arg)
  {
    this->imu_dropped_packets = _arg;
    return *this;
  }
  Type & set__gps_dropped_packets(
    const uint32_t & _arg)
  {
    this->gps_dropped_packets = _arg;
    return *this;
  }
  Type & set__filter_dropped_packets(
    const uint32_t & _arg)
  {
    this->filter_dropped_packets = _arg;
    return *this;
  }
  Type & set__com1_port_bytes_written(
    const uint32_t & _arg)
  {
    this->com1_port_bytes_written = _arg;
    return *this;
  }
  Type & set__com1_port_bytes_read(
    const uint32_t & _arg)
  {
    this->com1_port_bytes_read = _arg;
    return *this;
  }
  Type & set__com1_port_write_overruns(
    const uint32_t & _arg)
  {
    this->com1_port_write_overruns = _arg;
    return *this;
  }
  Type & set__com1_port_read_overruns(
    const uint32_t & _arg)
  {
    this->com1_port_read_overruns = _arg;
    return *this;
  }
  Type & set__imu_parser_errors(
    const uint32_t & _arg)
  {
    this->imu_parser_errors = _arg;
    return *this;
  }
  Type & set__imu_message_count(
    const uint32_t & _arg)
  {
    this->imu_message_count = _arg;
    return *this;
  }
  Type & set__imu_last_message_ms(
    const uint32_t & _arg)
  {
    this->imu_last_message_ms = _arg;
    return *this;
  }
  Type & set__gps_parser_errors(
    const uint32_t & _arg)
  {
    this->gps_parser_errors = _arg;
    return *this;
  }
  Type & set__gps_message_count(
    const uint32_t & _arg)
  {
    this->gps_message_count = _arg;
    return *this;
  }
  Type & set__gps_last_message_ms(
    const uint32_t & _arg)
  {
    this->gps_last_message_ms = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::Status_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::Status_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::Status_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::Status_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::Status_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::Status_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::Status_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::Status_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::Status_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::Status_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__Status
    std::shared_ptr<microstrain_inertial_msgs::msg::Status_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__Status
    std::shared_ptr<microstrain_inertial_msgs::msg::Status_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Status_ & other) const
  {
    if (this->device_model != other.device_model) {
      return false;
    }
    if (this->status_selector != other.status_selector) {
      return false;
    }
    if (this->status_flags != other.status_flags) {
      return false;
    }
    if (this->system_state != other.system_state) {
      return false;
    }
    if (this->system_timer_ms != other.system_timer_ms) {
      return false;
    }
    if (this->gps_power_on != other.gps_power_on) {
      return false;
    }
    if (this->num_gps_pps_triggers != other.num_gps_pps_triggers) {
      return false;
    }
    if (this->last_gps_pps_trigger_ms != other.last_gps_pps_trigger_ms) {
      return false;
    }
    if (this->imu_stream_enabled != other.imu_stream_enabled) {
      return false;
    }
    if (this->gps_stream_enabled != other.gps_stream_enabled) {
      return false;
    }
    if (this->filter_stream_enabled != other.filter_stream_enabled) {
      return false;
    }
    if (this->imu_dropped_packets != other.imu_dropped_packets) {
      return false;
    }
    if (this->gps_dropped_packets != other.gps_dropped_packets) {
      return false;
    }
    if (this->filter_dropped_packets != other.filter_dropped_packets) {
      return false;
    }
    if (this->com1_port_bytes_written != other.com1_port_bytes_written) {
      return false;
    }
    if (this->com1_port_bytes_read != other.com1_port_bytes_read) {
      return false;
    }
    if (this->com1_port_write_overruns != other.com1_port_write_overruns) {
      return false;
    }
    if (this->com1_port_read_overruns != other.com1_port_read_overruns) {
      return false;
    }
    if (this->imu_parser_errors != other.imu_parser_errors) {
      return false;
    }
    if (this->imu_message_count != other.imu_message_count) {
      return false;
    }
    if (this->imu_last_message_ms != other.imu_last_message_ms) {
      return false;
    }
    if (this->gps_parser_errors != other.gps_parser_errors) {
      return false;
    }
    if (this->gps_message_count != other.gps_message_count) {
      return false;
    }
    if (this->gps_last_message_ms != other.gps_last_message_ms) {
      return false;
    }
    return true;
  }
  bool operator!=(const Status_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Status_

// alias to use template instance with default allocator
using Status =
  microstrain_inertial_msgs::msg::Status_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__STATUS__STRUCT_HPP_
