// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:srv/DeviceReport.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__DEVICE_REPORT__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__DEVICE_REPORT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__DeviceReport_Request __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__DeviceReport_Request __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct DeviceReport_Request_
{
  using Type = DeviceReport_Request_<ContainerAllocator>;

  explicit DeviceReport_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit DeviceReport_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::DeviceReport_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::DeviceReport_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::DeviceReport_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::DeviceReport_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::DeviceReport_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::DeviceReport_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::DeviceReport_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::DeviceReport_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::DeviceReport_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::DeviceReport_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__DeviceReport_Request
    std::shared_ptr<microstrain_inertial_msgs::srv::DeviceReport_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__DeviceReport_Request
    std::shared_ptr<microstrain_inertial_msgs::srv::DeviceReport_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DeviceReport_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const DeviceReport_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DeviceReport_Request_

// alias to use template instance with default allocator
using DeviceReport_Request =
  microstrain_inertial_msgs::srv::DeviceReport_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace microstrain_inertial_msgs


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__DeviceReport_Response __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__DeviceReport_Response __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct DeviceReport_Response_
{
  using Type = DeviceReport_Response_<ContainerAllocator>;

  explicit DeviceReport_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->model_name = "";
      this->model_number = "";
      this->serial_number = "";
      this->options = "";
      this->firmware_version = "";
      this->success = false;
    }
  }

  explicit DeviceReport_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : model_name(_alloc),
    model_number(_alloc),
    serial_number(_alloc),
    options(_alloc),
    firmware_version(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->model_name = "";
      this->model_number = "";
      this->serial_number = "";
      this->options = "";
      this->firmware_version = "";
      this->success = false;
    }
  }

  // field types and members
  using _model_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _model_name_type model_name;
  using _model_number_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _model_number_type model_number;
  using _serial_number_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _serial_number_type serial_number;
  using _options_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _options_type options;
  using _firmware_version_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _firmware_version_type firmware_version;
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__model_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->model_name = _arg;
    return *this;
  }
  Type & set__model_number(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->model_number = _arg;
    return *this;
  }
  Type & set__serial_number(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->serial_number = _arg;
    return *this;
  }
  Type & set__options(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->options = _arg;
    return *this;
  }
  Type & set__firmware_version(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->firmware_version = _arg;
    return *this;
  }
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::DeviceReport_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::DeviceReport_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::DeviceReport_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::DeviceReport_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::DeviceReport_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::DeviceReport_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::DeviceReport_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::DeviceReport_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::DeviceReport_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::DeviceReport_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__DeviceReport_Response
    std::shared_ptr<microstrain_inertial_msgs::srv::DeviceReport_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__DeviceReport_Response
    std::shared_ptr<microstrain_inertial_msgs::srv::DeviceReport_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DeviceReport_Response_ & other) const
  {
    if (this->model_name != other.model_name) {
      return false;
    }
    if (this->model_number != other.model_number) {
      return false;
    }
    if (this->serial_number != other.serial_number) {
      return false;
    }
    if (this->options != other.options) {
      return false;
    }
    if (this->firmware_version != other.firmware_version) {
      return false;
    }
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const DeviceReport_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DeviceReport_Response_

// alias to use template instance with default allocator
using DeviceReport_Response =
  microstrain_inertial_msgs::srv::DeviceReport_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace microstrain_inertial_msgs
{

namespace srv
{

struct DeviceReport
{
  using Request = microstrain_inertial_msgs::srv::DeviceReport_Request;
  using Response = microstrain_inertial_msgs::srv::DeviceReport_Response;
};

}  // namespace srv

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__DEVICE_REPORT__STRUCT_HPP_
