// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:srv/ExternalHeadingUpdate.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__EXTERNAL_HEADING_UPDATE__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__EXTERNAL_HEADING_UPDATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__ExternalHeadingUpdate_Request __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__ExternalHeadingUpdate_Request __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ExternalHeadingUpdate_Request_
{
  using Type = ExternalHeadingUpdate_Request_<ContainerAllocator>;

  explicit ExternalHeadingUpdate_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0;
      this->gps_week_number = 0;
      this->heading_rad = 0.0f;
      this->heading_1sigma_rad = 0.0f;
      this->heading_type = 0;
      this->use_time = false;
    }
  }

  explicit ExternalHeadingUpdate_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0;
      this->gps_week_number = 0;
      this->heading_rad = 0.0f;
      this->heading_1sigma_rad = 0.0f;
      this->heading_type = 0;
      this->use_time = false;
    }
  }

  // field types and members
  using _gps_tow_type =
    double;
  _gps_tow_type gps_tow;
  using _gps_week_number_type =
    uint16_t;
  _gps_week_number_type gps_week_number;
  using _heading_rad_type =
    float;
  _heading_rad_type heading_rad;
  using _heading_1sigma_rad_type =
    float;
  _heading_1sigma_rad_type heading_1sigma_rad;
  using _heading_type_type =
    uint16_t;
  _heading_type_type heading_type;
  using _use_time_type =
    bool;
  _use_time_type use_time;

  // setters for named parameter idiom
  Type & set__gps_tow(
    const double & _arg)
  {
    this->gps_tow = _arg;
    return *this;
  }
  Type & set__gps_week_number(
    const uint16_t & _arg)
  {
    this->gps_week_number = _arg;
    return *this;
  }
  Type & set__heading_rad(
    const float & _arg)
  {
    this->heading_rad = _arg;
    return *this;
  }
  Type & set__heading_1sigma_rad(
    const float & _arg)
  {
    this->heading_1sigma_rad = _arg;
    return *this;
  }
  Type & set__heading_type(
    const uint16_t & _arg)
  {
    this->heading_type = _arg;
    return *this;
  }
  Type & set__use_time(
    const bool & _arg)
  {
    this->use_time = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint16_t HEADING_TYPE_TRUE =
    1u;
  static constexpr uint16_t HEADING_TYPE_MAGNETIC =
    2u;

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__ExternalHeadingUpdate_Request
    std::shared_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__ExternalHeadingUpdate_Request
    std::shared_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ExternalHeadingUpdate_Request_ & other) const
  {
    if (this->gps_tow != other.gps_tow) {
      return false;
    }
    if (this->gps_week_number != other.gps_week_number) {
      return false;
    }
    if (this->heading_rad != other.heading_rad) {
      return false;
    }
    if (this->heading_1sigma_rad != other.heading_1sigma_rad) {
      return false;
    }
    if (this->heading_type != other.heading_type) {
      return false;
    }
    if (this->use_time != other.use_time) {
      return false;
    }
    return true;
  }
  bool operator!=(const ExternalHeadingUpdate_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ExternalHeadingUpdate_Request_

// alias to use template instance with default allocator
using ExternalHeadingUpdate_Request =
  microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t ExternalHeadingUpdate_Request_<ContainerAllocator>::HEADING_TYPE_TRUE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t ExternalHeadingUpdate_Request_<ContainerAllocator>::HEADING_TYPE_MAGNETIC;
#endif  // __cplusplus < 201703L

}  // namespace srv

}  // namespace microstrain_inertial_msgs


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__ExternalHeadingUpdate_Response __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__ExternalHeadingUpdate_Response __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ExternalHeadingUpdate_Response_
{
  using Type = ExternalHeadingUpdate_Response_<ContainerAllocator>;

  explicit ExternalHeadingUpdate_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit ExternalHeadingUpdate_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__ExternalHeadingUpdate_Response
    std::shared_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__ExternalHeadingUpdate_Response
    std::shared_ptr<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ExternalHeadingUpdate_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const ExternalHeadingUpdate_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ExternalHeadingUpdate_Response_

// alias to use template instance with default allocator
using ExternalHeadingUpdate_Response =
  microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace microstrain_inertial_msgs
{

namespace srv
{

struct ExternalHeadingUpdate
{
  using Request = microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request;
  using Response = microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response;
};

}  // namespace srv

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__EXTERNAL_HEADING_UPDATE__STRUCT_HPP_
