// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:srv/ExternalHeadingUpdate.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__EXTERNAL_HEADING_UPDATE__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__EXTERNAL_HEADING_UPDATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "microstrain_inertial_msgs/srv/detail/external_heading_update__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace microstrain_inertial_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const ExternalHeadingUpdate_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: gps_tow
  {
    out << "gps_tow: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_tow, out);
    out << ", ";
  }

  // member: gps_week_number
  {
    out << "gps_week_number: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_week_number, out);
    out << ", ";
  }

  // member: heading_rad
  {
    out << "heading_rad: ";
    rosidl_generator_traits::value_to_yaml(msg.heading_rad, out);
    out << ", ";
  }

  // member: heading_1sigma_rad
  {
    out << "heading_1sigma_rad: ";
    rosidl_generator_traits::value_to_yaml(msg.heading_1sigma_rad, out);
    out << ", ";
  }

  // member: heading_type
  {
    out << "heading_type: ";
    rosidl_generator_traits::value_to_yaml(msg.heading_type, out);
    out << ", ";
  }

  // member: use_time
  {
    out << "use_time: ";
    rosidl_generator_traits::value_to_yaml(msg.use_time, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ExternalHeadingUpdate_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: gps_tow
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_tow: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_tow, out);
    out << "\n";
  }

  // member: gps_week_number
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_week_number: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_week_number, out);
    out << "\n";
  }

  // member: heading_rad
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading_rad: ";
    rosidl_generator_traits::value_to_yaml(msg.heading_rad, out);
    out << "\n";
  }

  // member: heading_1sigma_rad
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading_1sigma_rad: ";
    rosidl_generator_traits::value_to_yaml(msg.heading_1sigma_rad, out);
    out << "\n";
  }

  // member: heading_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading_type: ";
    rosidl_generator_traits::value_to_yaml(msg.heading_type, out);
    out << "\n";
  }

  // member: use_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "use_time: ";
    rosidl_generator_traits::value_to_yaml(msg.use_time, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ExternalHeadingUpdate_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request & msg)
{
  return microstrain_inertial_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request>()
{
  return "microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request>()
{
  return "microstrain_inertial_msgs/srv/ExternalHeadingUpdate_Request";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace microstrain_inertial_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const ExternalHeadingUpdate_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ExternalHeadingUpdate_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ExternalHeadingUpdate_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response & msg)
{
  return microstrain_inertial_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response>()
{
  return "microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response>()
{
  return "microstrain_inertial_msgs/srv/ExternalHeadingUpdate_Response";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::ExternalHeadingUpdate>()
{
  return "microstrain_inertial_msgs::srv::ExternalHeadingUpdate";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::ExternalHeadingUpdate>()
{
  return "microstrain_inertial_msgs/srv/ExternalHeadingUpdate";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::ExternalHeadingUpdate>
  : std::integral_constant<
    bool,
    has_fixed_size<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request>::value &&
    has_fixed_size<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response>::value
  >
{
};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::ExternalHeadingUpdate>
  : std::integral_constant<
    bool,
    has_bounded_size<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request>::value &&
    has_bounded_size<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response>::value
  >
{
};

template<>
struct is_service<microstrain_inertial_msgs::srv::ExternalHeadingUpdate>
  : std::true_type
{
};

template<>
struct is_service_request<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Request>
  : std::true_type
{
};

template<>
struct is_service_response<microstrain_inertial_msgs::srv::ExternalHeadingUpdate_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__EXTERNAL_HEADING_UPDATE__TRAITS_HPP_
