// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:srv/GetGravityAdaptiveVals.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_GRAVITY_ADAPTIVE_VALS__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_GRAVITY_ADAPTIVE_VALS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__GetGravityAdaptiveVals_Request __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__GetGravityAdaptiveVals_Request __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetGravityAdaptiveVals_Request_
{
  using Type = GetGravityAdaptiveVals_Request_<ContainerAllocator>;

  explicit GetGravityAdaptiveVals_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit GetGravityAdaptiveVals_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__GetGravityAdaptiveVals_Request
    std::shared_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__GetGravityAdaptiveVals_Request
    std::shared_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetGravityAdaptiveVals_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetGravityAdaptiveVals_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetGravityAdaptiveVals_Request_

// alias to use template instance with default allocator
using GetGravityAdaptiveVals_Request =
  microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace microstrain_inertial_msgs


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__GetGravityAdaptiveVals_Response __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__GetGravityAdaptiveVals_Response __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetGravityAdaptiveVals_Response_
{
  using Type = GetGravityAdaptiveVals_Response_<ContainerAllocator>;

  explicit GetGravityAdaptiveVals_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->enable = 0.0f;
      this->low_pass_cutoff = 0.0f;
      this->min_1sigma = 0.0f;
      this->low_limit = 0.0f;
      this->high_limit = 0.0f;
      this->low_limit_1sigma = 0.0f;
      this->high_limit_1sigma = 0.0f;
      this->success = false;
    }
  }

  explicit GetGravityAdaptiveVals_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->enable = 0.0f;
      this->low_pass_cutoff = 0.0f;
      this->min_1sigma = 0.0f;
      this->low_limit = 0.0f;
      this->high_limit = 0.0f;
      this->low_limit_1sigma = 0.0f;
      this->high_limit_1sigma = 0.0f;
      this->success = false;
    }
  }

  // field types and members
  using _enable_type =
    float;
  _enable_type enable;
  using _low_pass_cutoff_type =
    float;
  _low_pass_cutoff_type low_pass_cutoff;
  using _min_1sigma_type =
    float;
  _min_1sigma_type min_1sigma;
  using _low_limit_type =
    float;
  _low_limit_type low_limit;
  using _high_limit_type =
    float;
  _high_limit_type high_limit;
  using _low_limit_1sigma_type =
    float;
  _low_limit_1sigma_type low_limit_1sigma;
  using _high_limit_1sigma_type =
    float;
  _high_limit_1sigma_type high_limit_1sigma;
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__enable(
    const float & _arg)
  {
    this->enable = _arg;
    return *this;
  }
  Type & set__low_pass_cutoff(
    const float & _arg)
  {
    this->low_pass_cutoff = _arg;
    return *this;
  }
  Type & set__min_1sigma(
    const float & _arg)
  {
    this->min_1sigma = _arg;
    return *this;
  }
  Type & set__low_limit(
    const float & _arg)
  {
    this->low_limit = _arg;
    return *this;
  }
  Type & set__high_limit(
    const float & _arg)
  {
    this->high_limit = _arg;
    return *this;
  }
  Type & set__low_limit_1sigma(
    const float & _arg)
  {
    this->low_limit_1sigma = _arg;
    return *this;
  }
  Type & set__high_limit_1sigma(
    const float & _arg)
  {
    this->high_limit_1sigma = _arg;
    return *this;
  }
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__GetGravityAdaptiveVals_Response
    std::shared_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__GetGravityAdaptiveVals_Response
    std::shared_ptr<microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetGravityAdaptiveVals_Response_ & other) const
  {
    if (this->enable != other.enable) {
      return false;
    }
    if (this->low_pass_cutoff != other.low_pass_cutoff) {
      return false;
    }
    if (this->min_1sigma != other.min_1sigma) {
      return false;
    }
    if (this->low_limit != other.low_limit) {
      return false;
    }
    if (this->high_limit != other.high_limit) {
      return false;
    }
    if (this->low_limit_1sigma != other.low_limit_1sigma) {
      return false;
    }
    if (this->high_limit_1sigma != other.high_limit_1sigma) {
      return false;
    }
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetGravityAdaptiveVals_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetGravityAdaptiveVals_Response_

// alias to use template instance with default allocator
using GetGravityAdaptiveVals_Response =
  microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace microstrain_inertial_msgs
{

namespace srv
{

struct GetGravityAdaptiveVals
{
  using Request = microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Request;
  using Response = microstrain_inertial_msgs::srv::GetGravityAdaptiveVals_Response;
};

}  // namespace srv

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_GRAVITY_ADAPTIVE_VALS__STRUCT_HPP_
