// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:srv/GetSensor2VehicleRotation.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_SENSOR2_VEHICLE_ROTATION__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_SENSOR2_VEHICLE_ROTATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "microstrain_inertial_msgs/srv/detail/get_sensor2_vehicle_rotation__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace microstrain_inertial_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetSensor2VehicleRotation_Request & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetSensor2VehicleRotation_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetSensor2VehicleRotation_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Request & msg)
{
  return microstrain_inertial_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Request>()
{
  return "microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Request";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Request>()
{
  return "microstrain_inertial_msgs/srv/GetSensor2VehicleRotation_Request";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'angle'
#include "geometry_msgs/msg/detail/vector3__traits.hpp"

namespace microstrain_inertial_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetSensor2VehicleRotation_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: angle
  {
    out << "angle: ";
    to_flow_style_yaml(msg.angle, out);
    out << ", ";
  }

  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetSensor2VehicleRotation_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "angle:\n";
    to_block_style_yaml(msg.angle, out, indentation + 2);
  }

  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetSensor2VehicleRotation_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Response & msg)
{
  return microstrain_inertial_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Response>()
{
  return "microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Response";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Response>()
{
  return "microstrain_inertial_msgs/srv/GetSensor2VehicleRotation_Response";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Response>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Vector3>::value> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Response>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Vector3>::value> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation>()
{
  return "microstrain_inertial_msgs::srv::GetSensor2VehicleRotation";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation>()
{
  return "microstrain_inertial_msgs/srv/GetSensor2VehicleRotation";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation>
  : std::integral_constant<
    bool,
    has_fixed_size<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Request>::value &&
    has_fixed_size<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Response>::value
  >
{
};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation>
  : std::integral_constant<
    bool,
    has_bounded_size<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Request>::value &&
    has_bounded_size<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Response>::value
  >
{
};

template<>
struct is_service<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation>
  : std::true_type
{
};

template<>
struct is_service_request<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Request>
  : std::true_type
{
};

template<>
struct is_service_response<microstrain_inertial_msgs::srv::GetSensor2VehicleRotation_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_SENSOR2_VEHICLE_ROTATION__TRAITS_HPP_
