// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:srv/SetAccelAdaptiveVals.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_ACCEL_ADAPTIVE_VALS__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_ACCEL_ADAPTIVE_VALS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "microstrain_inertial_msgs/srv/detail/set_accel_adaptive_vals__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace microstrain_inertial_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetAccelAdaptiveVals_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: enable
  {
    out << "enable: ";
    rosidl_generator_traits::value_to_yaml(msg.enable, out);
    out << ", ";
  }

  // member: low_pass_cutoff
  {
    out << "low_pass_cutoff: ";
    rosidl_generator_traits::value_to_yaml(msg.low_pass_cutoff, out);
    out << ", ";
  }

  // member: min_1sigma
  {
    out << "min_1sigma: ";
    rosidl_generator_traits::value_to_yaml(msg.min_1sigma, out);
    out << ", ";
  }

  // member: low_limit
  {
    out << "low_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.low_limit, out);
    out << ", ";
  }

  // member: high_limit
  {
    out << "high_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.high_limit, out);
    out << ", ";
  }

  // member: low_limit_1sigma
  {
    out << "low_limit_1sigma: ";
    rosidl_generator_traits::value_to_yaml(msg.low_limit_1sigma, out);
    out << ", ";
  }

  // member: high_limit_1sigma
  {
    out << "high_limit_1sigma: ";
    rosidl_generator_traits::value_to_yaml(msg.high_limit_1sigma, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetAccelAdaptiveVals_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: enable
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "enable: ";
    rosidl_generator_traits::value_to_yaml(msg.enable, out);
    out << "\n";
  }

  // member: low_pass_cutoff
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "low_pass_cutoff: ";
    rosidl_generator_traits::value_to_yaml(msg.low_pass_cutoff, out);
    out << "\n";
  }

  // member: min_1sigma
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_1sigma: ";
    rosidl_generator_traits::value_to_yaml(msg.min_1sigma, out);
    out << "\n";
  }

  // member: low_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "low_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.low_limit, out);
    out << "\n";
  }

  // member: high_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "high_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.high_limit, out);
    out << "\n";
  }

  // member: low_limit_1sigma
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "low_limit_1sigma: ";
    rosidl_generator_traits::value_to_yaml(msg.low_limit_1sigma, out);
    out << "\n";
  }

  // member: high_limit_1sigma
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "high_limit_1sigma: ";
    rosidl_generator_traits::value_to_yaml(msg.high_limit_1sigma, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetAccelAdaptiveVals_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Request & msg)
{
  return microstrain_inertial_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Request>()
{
  return "microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Request";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Request>()
{
  return "microstrain_inertial_msgs/srv/SetAccelAdaptiveVals_Request";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace microstrain_inertial_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetAccelAdaptiveVals_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetAccelAdaptiveVals_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetAccelAdaptiveVals_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Response & msg)
{
  return microstrain_inertial_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Response>()
{
  return "microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Response";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Response>()
{
  return "microstrain_inertial_msgs/srv/SetAccelAdaptiveVals_Response";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals>()
{
  return "microstrain_inertial_msgs::srv::SetAccelAdaptiveVals";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals>()
{
  return "microstrain_inertial_msgs/srv/SetAccelAdaptiveVals";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals>
  : std::integral_constant<
    bool,
    has_fixed_size<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Request>::value &&
    has_fixed_size<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Response>::value
  >
{
};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals>
  : std::integral_constant<
    bool,
    has_bounded_size<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Request>::value &&
    has_bounded_size<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Response>::value
  >
{
};

template<>
struct is_service<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals>
  : std::true_type
{
};

template<>
struct is_service_request<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Request>
  : std::true_type
{
};

template<>
struct is_service_response<microstrain_inertial_msgs::srv::SetAccelAdaptiveVals_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_ACCEL_ADAPTIVE_VALS__TRAITS_HPP_
