// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:srv/SetEstimationControlFlags.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_ESTIMATION_CONTROL_FLAGS__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_ESTIMATION_CONTROL_FLAGS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__SetEstimationControlFlags_Request __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__SetEstimationControlFlags_Request __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetEstimationControlFlags_Request_
{
  using Type = SetEstimationControlFlags_Request_<ContainerAllocator>;

  explicit SetEstimationControlFlags_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->flags = 0;
    }
  }

  explicit SetEstimationControlFlags_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->flags = 0;
    }
  }

  // field types and members
  using _flags_type =
    int8_t;
  _flags_type flags;

  // setters for named parameter idiom
  Type & set__flags(
    const int8_t & _arg)
  {
    this->flags = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int8_t GYRO_BIAS_ESTIMATION =
    1;
  static constexpr int8_t HARD_IRON_AUTO_CALIBRATION =
    32;
  static constexpr int8_t SOFT_IRON_AUTO_CALIBRATION =
    64;

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__SetEstimationControlFlags_Request
    std::shared_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__SetEstimationControlFlags_Request
    std::shared_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetEstimationControlFlags_Request_ & other) const
  {
    if (this->flags != other.flags) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetEstimationControlFlags_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetEstimationControlFlags_Request_

// alias to use template instance with default allocator
using SetEstimationControlFlags_Request =
  microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t SetEstimationControlFlags_Request_<ContainerAllocator>::GYRO_BIAS_ESTIMATION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t SetEstimationControlFlags_Request_<ContainerAllocator>::HARD_IRON_AUTO_CALIBRATION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t SetEstimationControlFlags_Request_<ContainerAllocator>::SOFT_IRON_AUTO_CALIBRATION;
#endif  // __cplusplus < 201703L

}  // namespace srv

}  // namespace microstrain_inertial_msgs


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__SetEstimationControlFlags_Response __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__SetEstimationControlFlags_Response __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetEstimationControlFlags_Response_
{
  using Type = SetEstimationControlFlags_Response_<ContainerAllocator>;

  explicit SetEstimationControlFlags_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit SetEstimationControlFlags_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__SetEstimationControlFlags_Response
    std::shared_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__SetEstimationControlFlags_Response
    std::shared_ptr<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetEstimationControlFlags_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetEstimationControlFlags_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetEstimationControlFlags_Response_

// alias to use template instance with default allocator
using SetEstimationControlFlags_Response =
  microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace microstrain_inertial_msgs
{

namespace srv
{

struct SetEstimationControlFlags
{
  using Request = microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request;
  using Response = microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response;
};

}  // namespace srv

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_ESTIMATION_CONTROL_FLAGS__STRUCT_HPP_
