// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/FilterHeadingState.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_HEADING_STATE__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_HEADING_STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__FilterHeadingState __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__FilterHeadingState __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FilterHeadingState_
{
  using Type = FilterHeadingState_<ContainerAllocator>;

  explicit FilterHeadingState_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->heading_rad = 0.0f;
      this->heading_uncertainty = 0.0f;
      this->source = 0;
      this->status_flags = 0;
    }
  }

  explicit FilterHeadingState_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->heading_rad = 0.0f;
      this->heading_uncertainty = 0.0f;
      this->source = 0;
      this->status_flags = 0;
    }
  }

  // field types and members
  using _heading_rad_type =
    float;
  _heading_rad_type heading_rad;
  using _heading_uncertainty_type =
    float;
  _heading_uncertainty_type heading_uncertainty;
  using _source_type =
    uint16_t;
  _source_type source;
  using _status_flags_type =
    uint16_t;
  _status_flags_type status_flags;

  // setters for named parameter idiom
  Type & set__heading_rad(
    const float & _arg)
  {
    this->heading_rad = _arg;
    return *this;
  }
  Type & set__heading_uncertainty(
    const float & _arg)
  {
    this->heading_uncertainty = _arg;
    return *this;
  }
  Type & set__source(
    const uint16_t & _arg)
  {
    this->source = _arg;
    return *this;
  }
  Type & set__status_flags(
    const uint16_t & _arg)
  {
    this->status_flags = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::FilterHeadingState_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::FilterHeadingState_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::FilterHeadingState_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::FilterHeadingState_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::FilterHeadingState_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::FilterHeadingState_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::FilterHeadingState_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::FilterHeadingState_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::FilterHeadingState_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::FilterHeadingState_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__FilterHeadingState
    std::shared_ptr<microstrain_inertial_msgs::msg::FilterHeadingState_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__FilterHeadingState
    std::shared_ptr<microstrain_inertial_msgs::msg::FilterHeadingState_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FilterHeadingState_ & other) const
  {
    if (this->heading_rad != other.heading_rad) {
      return false;
    }
    if (this->heading_uncertainty != other.heading_uncertainty) {
      return false;
    }
    if (this->source != other.source) {
      return false;
    }
    if (this->status_flags != other.status_flags) {
      return false;
    }
    return true;
  }
  bool operator!=(const FilterHeadingState_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FilterHeadingState_

// alias to use template instance with default allocator
using FilterHeadingState =
  microstrain_inertial_msgs::msg::FilterHeadingState_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_HEADING_STATE__STRUCT_HPP_
