// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from microstrain_inertial_msgs:msg/FilterStatus.idl
// generated code does not contain a copyright notice
#include "microstrain_inertial_msgs/msg/detail/filter_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
microstrain_inertial_msgs__msg__FilterStatus__init(microstrain_inertial_msgs__msg__FilterStatus * msg)
{
  if (!msg) {
    return false;
  }
  // filter_state
  // dynamics_mode
  // status_flags
  return true;
}

void
microstrain_inertial_msgs__msg__FilterStatus__fini(microstrain_inertial_msgs__msg__FilterStatus * msg)
{
  if (!msg) {
    return;
  }
  // filter_state
  // dynamics_mode
  // status_flags
}

bool
microstrain_inertial_msgs__msg__FilterStatus__are_equal(const microstrain_inertial_msgs__msg__FilterStatus * lhs, const microstrain_inertial_msgs__msg__FilterStatus * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // filter_state
  if (lhs->filter_state != rhs->filter_state) {
    return false;
  }
  // dynamics_mode
  if (lhs->dynamics_mode != rhs->dynamics_mode) {
    return false;
  }
  // status_flags
  if (lhs->status_flags != rhs->status_flags) {
    return false;
  }
  return true;
}

bool
microstrain_inertial_msgs__msg__FilterStatus__copy(
  const microstrain_inertial_msgs__msg__FilterStatus * input,
  microstrain_inertial_msgs__msg__FilterStatus * output)
{
  if (!input || !output) {
    return false;
  }
  // filter_state
  output->filter_state = input->filter_state;
  // dynamics_mode
  output->dynamics_mode = input->dynamics_mode;
  // status_flags
  output->status_flags = input->status_flags;
  return true;
}

microstrain_inertial_msgs__msg__FilterStatus *
microstrain_inertial_msgs__msg__FilterStatus__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__FilterStatus * msg = (microstrain_inertial_msgs__msg__FilterStatus *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__FilterStatus), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(microstrain_inertial_msgs__msg__FilterStatus));
  bool success = microstrain_inertial_msgs__msg__FilterStatus__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
microstrain_inertial_msgs__msg__FilterStatus__destroy(microstrain_inertial_msgs__msg__FilterStatus * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    microstrain_inertial_msgs__msg__FilterStatus__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
microstrain_inertial_msgs__msg__FilterStatus__Sequence__init(microstrain_inertial_msgs__msg__FilterStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__FilterStatus * data = NULL;

  if (size) {
    data = (microstrain_inertial_msgs__msg__FilterStatus *)allocator.zero_allocate(size, sizeof(microstrain_inertial_msgs__msg__FilterStatus), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = microstrain_inertial_msgs__msg__FilterStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        microstrain_inertial_msgs__msg__FilterStatus__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
microstrain_inertial_msgs__msg__FilterStatus__Sequence__fini(microstrain_inertial_msgs__msg__FilterStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      microstrain_inertial_msgs__msg__FilterStatus__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

microstrain_inertial_msgs__msg__FilterStatus__Sequence *
microstrain_inertial_msgs__msg__FilterStatus__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__FilterStatus__Sequence * array = (microstrain_inertial_msgs__msg__FilterStatus__Sequence *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__FilterStatus__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = microstrain_inertial_msgs__msg__FilterStatus__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
microstrain_inertial_msgs__msg__FilterStatus__Sequence__destroy(microstrain_inertial_msgs__msg__FilterStatus__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    microstrain_inertial_msgs__msg__FilterStatus__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
microstrain_inertial_msgs__msg__FilterStatus__Sequence__are_equal(const microstrain_inertial_msgs__msg__FilterStatus__Sequence * lhs, const microstrain_inertial_msgs__msg__FilterStatus__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!microstrain_inertial_msgs__msg__FilterStatus__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
microstrain_inertial_msgs__msg__FilterStatus__Sequence__copy(
  const microstrain_inertial_msgs__msg__FilterStatus__Sequence * input,
  microstrain_inertial_msgs__msg__FilterStatus__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(microstrain_inertial_msgs__msg__FilterStatus);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    microstrain_inertial_msgs__msg__FilterStatus * data =
      (microstrain_inertial_msgs__msg__FilterStatus *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!microstrain_inertial_msgs__msg__FilterStatus__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          microstrain_inertial_msgs__msg__FilterStatus__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!microstrain_inertial_msgs__msg__FilterStatus__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
