// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/FilterStatus.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_STATUS__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__FilterStatus __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__FilterStatus __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FilterStatus_
{
  using Type = FilterStatus_<ContainerAllocator>;

  explicit FilterStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->filter_state = 0;
      this->dynamics_mode = 0;
      this->status_flags = 0;
    }
  }

  explicit FilterStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->filter_state = 0;
      this->dynamics_mode = 0;
      this->status_flags = 0;
    }
  }

  // field types and members
  using _filter_state_type =
    uint16_t;
  _filter_state_type filter_state;
  using _dynamics_mode_type =
    uint16_t;
  _dynamics_mode_type dynamics_mode;
  using _status_flags_type =
    uint16_t;
  _status_flags_type status_flags;

  // setters for named parameter idiom
  Type & set__filter_state(
    const uint16_t & _arg)
  {
    this->filter_state = _arg;
    return *this;
  }
  Type & set__dynamics_mode(
    const uint16_t & _arg)
  {
    this->dynamics_mode = _arg;
    return *this;
  }
  Type & set__status_flags(
    const uint16_t & _arg)
  {
    this->status_flags = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::FilterStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::FilterStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::FilterStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::FilterStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::FilterStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::FilterStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::FilterStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::FilterStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::FilterStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::FilterStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__FilterStatus
    std::shared_ptr<microstrain_inertial_msgs::msg::FilterStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__FilterStatus
    std::shared_ptr<microstrain_inertial_msgs::msg::FilterStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FilterStatus_ & other) const
  {
    if (this->filter_state != other.filter_state) {
      return false;
    }
    if (this->dynamics_mode != other.dynamics_mode) {
      return false;
    }
    if (this->status_flags != other.status_flags) {
      return false;
    }
    return true;
  }
  bool operator!=(const FilterStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FilterStatus_

// alias to use template instance with default allocator
using FilterStatus =
  microstrain_inertial_msgs::msg::FilterStatus_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_STATUS__STRUCT_HPP_
