// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:msg/FilterStatus.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_STATUS__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_STATUS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "microstrain_inertial_msgs/msg/detail/filter_status__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace microstrain_inertial_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const FilterStatus & msg,
  std::ostream & out)
{
  out << "{";
  // member: filter_state
  {
    out << "filter_state: ";
    rosidl_generator_traits::value_to_yaml(msg.filter_state, out);
    out << ", ";
  }

  // member: dynamics_mode
  {
    out << "dynamics_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.dynamics_mode, out);
    out << ", ";
  }

  // member: status_flags
  {
    out << "status_flags: ";
    rosidl_generator_traits::value_to_yaml(msg.status_flags, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FilterStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: filter_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "filter_state: ";
    rosidl_generator_traits::value_to_yaml(msg.filter_state, out);
    out << "\n";
  }

  // member: dynamics_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dynamics_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.dynamics_mode, out);
    out << "\n";
  }

  // member: status_flags
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status_flags: ";
    rosidl_generator_traits::value_to_yaml(msg.status_flags, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FilterStatus & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::msg::FilterStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::msg::FilterStatus & msg)
{
  return microstrain_inertial_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::msg::FilterStatus>()
{
  return "microstrain_inertial_msgs::msg::FilterStatus";
}

template<>
inline const char * name<microstrain_inertial_msgs::msg::FilterStatus>()
{
  return "microstrain_inertial_msgs/msg/FilterStatus";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::msg::FilterStatus>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::msg::FilterStatus>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::msg::FilterStatus>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__FILTER_STATUS__TRAITS_HPP_
