// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:msg/GNSSAidingStatus.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_AIDING_STATUS__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_AIDING_STATUS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "microstrain_inertial_msgs/msg/detail/gnss_aiding_status__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace microstrain_inertial_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const GNSSAidingStatus & msg,
  std::ostream & out)
{
  out << "{";
  // member: gps_tow
  {
    out << "gps_tow: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_tow, out);
    out << ", ";
  }

  // member: has_position_fix
  {
    out << "has_position_fix: ";
    rosidl_generator_traits::value_to_yaml(msg.has_position_fix, out);
    out << ", ";
  }

  // member: tight_coupling
  {
    out << "tight_coupling: ";
    rosidl_generator_traits::value_to_yaml(msg.tight_coupling, out);
    out << ", ";
  }

  // member: differential_corrections
  {
    out << "differential_corrections: ";
    rosidl_generator_traits::value_to_yaml(msg.differential_corrections, out);
    out << ", ";
  }

  // member: integer_fix
  {
    out << "integer_fix: ";
    rosidl_generator_traits::value_to_yaml(msg.integer_fix, out);
    out << ", ";
  }

  // member: using_gps
  {
    out << "using_gps: ";
    rosidl_generator_traits::value_to_yaml(msg.using_gps, out);
    out << ", ";
  }

  // member: using_glonass
  {
    out << "using_glonass: ";
    rosidl_generator_traits::value_to_yaml(msg.using_glonass, out);
    out << ", ";
  }

  // member: using_galileo
  {
    out << "using_galileo: ";
    rosidl_generator_traits::value_to_yaml(msg.using_galileo, out);
    out << ", ";
  }

  // member: using_beidou
  {
    out << "using_beidou: ";
    rosidl_generator_traits::value_to_yaml(msg.using_beidou, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GNSSAidingStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: gps_tow
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_tow: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_tow, out);
    out << "\n";
  }

  // member: has_position_fix
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "has_position_fix: ";
    rosidl_generator_traits::value_to_yaml(msg.has_position_fix, out);
    out << "\n";
  }

  // member: tight_coupling
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "tight_coupling: ";
    rosidl_generator_traits::value_to_yaml(msg.tight_coupling, out);
    out << "\n";
  }

  // member: differential_corrections
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "differential_corrections: ";
    rosidl_generator_traits::value_to_yaml(msg.differential_corrections, out);
    out << "\n";
  }

  // member: integer_fix
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "integer_fix: ";
    rosidl_generator_traits::value_to_yaml(msg.integer_fix, out);
    out << "\n";
  }

  // member: using_gps
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "using_gps: ";
    rosidl_generator_traits::value_to_yaml(msg.using_gps, out);
    out << "\n";
  }

  // member: using_glonass
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "using_glonass: ";
    rosidl_generator_traits::value_to_yaml(msg.using_glonass, out);
    out << "\n";
  }

  // member: using_galileo
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "using_galileo: ";
    rosidl_generator_traits::value_to_yaml(msg.using_galileo, out);
    out << "\n";
  }

  // member: using_beidou
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "using_beidou: ";
    rosidl_generator_traits::value_to_yaml(msg.using_beidou, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GNSSAidingStatus & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::msg::GNSSAidingStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::msg::GNSSAidingStatus & msg)
{
  return microstrain_inertial_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::msg::GNSSAidingStatus>()
{
  return "microstrain_inertial_msgs::msg::GNSSAidingStatus";
}

template<>
inline const char * name<microstrain_inertial_msgs::msg::GNSSAidingStatus>()
{
  return "microstrain_inertial_msgs/msg/GNSSAidingStatus";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::msg::GNSSAidingStatus>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::msg::GNSSAidingStatus>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::msg::GNSSAidingStatus>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_AIDING_STATUS__TRAITS_HPP_
