// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/GNSSAntennaOffsetCorrection.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_ANTENNA_OFFSET_CORRECTION__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_ANTENNA_OFFSET_CORRECTION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__GNSSAntennaOffsetCorrection __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__GNSSAntennaOffsetCorrection __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GNSSAntennaOffsetCorrection_
{
  using Type = GNSSAntennaOffsetCorrection_<ContainerAllocator>;

  explicit GNSSAntennaOffsetCorrection_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<float, 3>::iterator, float>(this->offset.begin(), this->offset.end(), 0.0f);
    }
  }

  explicit GNSSAntennaOffsetCorrection_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : offset(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<float, 3>::iterator, float>(this->offset.begin(), this->offset.end(), 0.0f);
    }
  }

  // field types and members
  using _offset_type =
    std::array<float, 3>;
  _offset_type offset;

  // setters for named parameter idiom
  Type & set__offset(
    const std::array<float, 3> & _arg)
  {
    this->offset = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::GNSSAntennaOffsetCorrection_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::GNSSAntennaOffsetCorrection_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSAntennaOffsetCorrection_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSAntennaOffsetCorrection_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::GNSSAntennaOffsetCorrection_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::GNSSAntennaOffsetCorrection_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::GNSSAntennaOffsetCorrection_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::GNSSAntennaOffsetCorrection_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::GNSSAntennaOffsetCorrection_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::GNSSAntennaOffsetCorrection_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__GNSSAntennaOffsetCorrection
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSAntennaOffsetCorrection_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__GNSSAntennaOffsetCorrection
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSAntennaOffsetCorrection_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GNSSAntennaOffsetCorrection_ & other) const
  {
    if (this->offset != other.offset) {
      return false;
    }
    return true;
  }
  bool operator!=(const GNSSAntennaOffsetCorrection_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GNSSAntennaOffsetCorrection_

// alias to use template instance with default allocator
using GNSSAntennaOffsetCorrection =
  microstrain_inertial_msgs::msg::GNSSAntennaOffsetCorrection_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_ANTENNA_OFFSET_CORRECTION__STRUCT_HPP_
