// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from microstrain_inertial_msgs:msg/GNSSDualAntennaStatus.idl
// generated code does not contain a copyright notice
#include "microstrain_inertial_msgs/msg/detail/gnss_dual_antenna_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__init(microstrain_inertial_msgs__msg__GNSSDualAntennaStatus * msg)
{
  if (!msg) {
    return false;
  }
  // gps_tow
  // heading
  // heading_uncertainty
  // fix_type
  // rcv_1_valid
  // rcv_2_valid
  // antenna_offsets_valid
  return true;
}

void
microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__fini(microstrain_inertial_msgs__msg__GNSSDualAntennaStatus * msg)
{
  if (!msg) {
    return;
  }
  // gps_tow
  // heading
  // heading_uncertainty
  // fix_type
  // rcv_1_valid
  // rcv_2_valid
  // antenna_offsets_valid
}

bool
microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__are_equal(const microstrain_inertial_msgs__msg__GNSSDualAntennaStatus * lhs, const microstrain_inertial_msgs__msg__GNSSDualAntennaStatus * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // gps_tow
  if (lhs->gps_tow != rhs->gps_tow) {
    return false;
  }
  // heading
  if (lhs->heading != rhs->heading) {
    return false;
  }
  // heading_uncertainty
  if (lhs->heading_uncertainty != rhs->heading_uncertainty) {
    return false;
  }
  // fix_type
  if (lhs->fix_type != rhs->fix_type) {
    return false;
  }
  // rcv_1_valid
  if (lhs->rcv_1_valid != rhs->rcv_1_valid) {
    return false;
  }
  // rcv_2_valid
  if (lhs->rcv_2_valid != rhs->rcv_2_valid) {
    return false;
  }
  // antenna_offsets_valid
  if (lhs->antenna_offsets_valid != rhs->antenna_offsets_valid) {
    return false;
  }
  return true;
}

bool
microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__copy(
  const microstrain_inertial_msgs__msg__GNSSDualAntennaStatus * input,
  microstrain_inertial_msgs__msg__GNSSDualAntennaStatus * output)
{
  if (!input || !output) {
    return false;
  }
  // gps_tow
  output->gps_tow = input->gps_tow;
  // heading
  output->heading = input->heading;
  // heading_uncertainty
  output->heading_uncertainty = input->heading_uncertainty;
  // fix_type
  output->fix_type = input->fix_type;
  // rcv_1_valid
  output->rcv_1_valid = input->rcv_1_valid;
  // rcv_2_valid
  output->rcv_2_valid = input->rcv_2_valid;
  // antenna_offsets_valid
  output->antenna_offsets_valid = input->antenna_offsets_valid;
  return true;
}

microstrain_inertial_msgs__msg__GNSSDualAntennaStatus *
microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__GNSSDualAntennaStatus * msg = (microstrain_inertial_msgs__msg__GNSSDualAntennaStatus *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__GNSSDualAntennaStatus), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(microstrain_inertial_msgs__msg__GNSSDualAntennaStatus));
  bool success = microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__destroy(microstrain_inertial_msgs__msg__GNSSDualAntennaStatus * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence__init(microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__GNSSDualAntennaStatus * data = NULL;

  if (size) {
    data = (microstrain_inertial_msgs__msg__GNSSDualAntennaStatus *)allocator.zero_allocate(size, sizeof(microstrain_inertial_msgs__msg__GNSSDualAntennaStatus), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence__fini(microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence *
microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence * array = (microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence__destroy(microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence__are_equal(const microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence * lhs, const microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence__copy(
  const microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence * input,
  microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(microstrain_inertial_msgs__msg__GNSSDualAntennaStatus);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    microstrain_inertial_msgs__msg__GNSSDualAntennaStatus * data =
      (microstrain_inertial_msgs__msg__GNSSDualAntennaStatus *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!microstrain_inertial_msgs__msg__GNSSDualAntennaStatus__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
