// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/GNSSDualAntennaStatus.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_DUAL_ANTENNA_STATUS__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_DUAL_ANTENNA_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__GNSSDualAntennaStatus __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__GNSSDualAntennaStatus __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GNSSDualAntennaStatus_
{
  using Type = GNSSDualAntennaStatus_<ContainerAllocator>;

  explicit GNSSDualAntennaStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0f;
      this->heading = 0.0f;
      this->heading_uncertainty = 0.0f;
      this->fix_type = 0;
      this->rcv_1_valid = 0;
      this->rcv_2_valid = 0;
      this->antenna_offsets_valid = 0;
    }
  }

  explicit GNSSDualAntennaStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0f;
      this->heading = 0.0f;
      this->heading_uncertainty = 0.0f;
      this->fix_type = 0;
      this->rcv_1_valid = 0;
      this->rcv_2_valid = 0;
      this->antenna_offsets_valid = 0;
    }
  }

  // field types and members
  using _gps_tow_type =
    float;
  _gps_tow_type gps_tow;
  using _heading_type =
    float;
  _heading_type heading;
  using _heading_uncertainty_type =
    float;
  _heading_uncertainty_type heading_uncertainty;
  using _fix_type_type =
    uint8_t;
  _fix_type_type fix_type;
  using _rcv_1_valid_type =
    uint8_t;
  _rcv_1_valid_type rcv_1_valid;
  using _rcv_2_valid_type =
    uint8_t;
  _rcv_2_valid_type rcv_2_valid;
  using _antenna_offsets_valid_type =
    uint8_t;
  _antenna_offsets_valid_type antenna_offsets_valid;

  // setters for named parameter idiom
  Type & set__gps_tow(
    const float & _arg)
  {
    this->gps_tow = _arg;
    return *this;
  }
  Type & set__heading(
    const float & _arg)
  {
    this->heading = _arg;
    return *this;
  }
  Type & set__heading_uncertainty(
    const float & _arg)
  {
    this->heading_uncertainty = _arg;
    return *this;
  }
  Type & set__fix_type(
    const uint8_t & _arg)
  {
    this->fix_type = _arg;
    return *this;
  }
  Type & set__rcv_1_valid(
    const uint8_t & _arg)
  {
    this->rcv_1_valid = _arg;
    return *this;
  }
  Type & set__rcv_2_valid(
    const uint8_t & _arg)
  {
    this->rcv_2_valid = _arg;
    return *this;
  }
  Type & set__antenna_offsets_valid(
    const uint8_t & _arg)
  {
    this->antenna_offsets_valid = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::GNSSDualAntennaStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::GNSSDualAntennaStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSDualAntennaStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSDualAntennaStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::GNSSDualAntennaStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::GNSSDualAntennaStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::GNSSDualAntennaStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::GNSSDualAntennaStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::GNSSDualAntennaStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::GNSSDualAntennaStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__GNSSDualAntennaStatus
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSDualAntennaStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__GNSSDualAntennaStatus
    std::shared_ptr<microstrain_inertial_msgs::msg::GNSSDualAntennaStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GNSSDualAntennaStatus_ & other) const
  {
    if (this->gps_tow != other.gps_tow) {
      return false;
    }
    if (this->heading != other.heading) {
      return false;
    }
    if (this->heading_uncertainty != other.heading_uncertainty) {
      return false;
    }
    if (this->fix_type != other.fix_type) {
      return false;
    }
    if (this->rcv_1_valid != other.rcv_1_valid) {
      return false;
    }
    if (this->rcv_2_valid != other.rcv_2_valid) {
      return false;
    }
    if (this->antenna_offsets_valid != other.antenna_offsets_valid) {
      return false;
    }
    return true;
  }
  bool operator!=(const GNSSDualAntennaStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GNSSDualAntennaStatus_

// alias to use template instance with default allocator
using GNSSDualAntennaStatus =
  microstrain_inertial_msgs::msg::GNSSDualAntennaStatus_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_DUAL_ANTENNA_STATUS__STRUCT_HPP_
