// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:msg/GNSSDualAntennaStatus.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_DUAL_ANTENNA_STATUS__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_DUAL_ANTENNA_STATUS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "microstrain_inertial_msgs/msg/detail/gnss_dual_antenna_status__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace microstrain_inertial_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const GNSSDualAntennaStatus & msg,
  std::ostream & out)
{
  out << "{";
  // member: gps_tow
  {
    out << "gps_tow: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_tow, out);
    out << ", ";
  }

  // member: heading
  {
    out << "heading: ";
    rosidl_generator_traits::value_to_yaml(msg.heading, out);
    out << ", ";
  }

  // member: heading_uncertainty
  {
    out << "heading_uncertainty: ";
    rosidl_generator_traits::value_to_yaml(msg.heading_uncertainty, out);
    out << ", ";
  }

  // member: fix_type
  {
    out << "fix_type: ";
    rosidl_generator_traits::value_to_yaml(msg.fix_type, out);
    out << ", ";
  }

  // member: rcv_1_valid
  {
    out << "rcv_1_valid: ";
    rosidl_generator_traits::value_to_yaml(msg.rcv_1_valid, out);
    out << ", ";
  }

  // member: rcv_2_valid
  {
    out << "rcv_2_valid: ";
    rosidl_generator_traits::value_to_yaml(msg.rcv_2_valid, out);
    out << ", ";
  }

  // member: antenna_offsets_valid
  {
    out << "antenna_offsets_valid: ";
    rosidl_generator_traits::value_to_yaml(msg.antenna_offsets_valid, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GNSSDualAntennaStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: gps_tow
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_tow: ";
    rosidl_generator_traits::value_to_yaml(msg.gps_tow, out);
    out << "\n";
  }

  // member: heading
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading: ";
    rosidl_generator_traits::value_to_yaml(msg.heading, out);
    out << "\n";
  }

  // member: heading_uncertainty
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading_uncertainty: ";
    rosidl_generator_traits::value_to_yaml(msg.heading_uncertainty, out);
    out << "\n";
  }

  // member: fix_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fix_type: ";
    rosidl_generator_traits::value_to_yaml(msg.fix_type, out);
    out << "\n";
  }

  // member: rcv_1_valid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rcv_1_valid: ";
    rosidl_generator_traits::value_to_yaml(msg.rcv_1_valid, out);
    out << "\n";
  }

  // member: rcv_2_valid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rcv_2_valid: ";
    rosidl_generator_traits::value_to_yaml(msg.rcv_2_valid, out);
    out << "\n";
  }

  // member: antenna_offsets_valid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "antenna_offsets_valid: ";
    rosidl_generator_traits::value_to_yaml(msg.antenna_offsets_valid, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GNSSDualAntennaStatus & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::msg::GNSSDualAntennaStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::msg::GNSSDualAntennaStatus & msg)
{
  return microstrain_inertial_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::msg::GNSSDualAntennaStatus>()
{
  return "microstrain_inertial_msgs::msg::GNSSDualAntennaStatus";
}

template<>
inline const char * name<microstrain_inertial_msgs::msg::GNSSDualAntennaStatus>()
{
  return "microstrain_inertial_msgs/msg/GNSSDualAntennaStatus";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::msg::GNSSDualAntennaStatus>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::msg::GNSSDualAntennaStatus>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::msg::GNSSDualAntennaStatus>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_DUAL_ANTENNA_STATUS__TRAITS_HPP_
