// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from microstrain_inertial_msgs:msg/GNSSRfErrorDetection.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_RF_ERROR_DETECTION__STRUCT_H_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_RF_ERROR_DETECTION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'RF_BAND_UNKNOWN'.
/**
  * Enum values for rf_band field
 */
enum
{
  microstrain_inertial_msgs__msg__GNSSRfErrorDetection__RF_BAND_UNKNOWN = 0
};

/// Constant 'RF_BAND_L1'.
enum
{
  microstrain_inertial_msgs__msg__GNSSRfErrorDetection__RF_BAND_L1 = 1
};

/// Constant 'RF_BAND_L2'.
enum
{
  microstrain_inertial_msgs__msg__GNSSRfErrorDetection__RF_BAND_L2 = 2
};

/// Constant 'RF_BAND_L5'.
enum
{
  microstrain_inertial_msgs__msg__GNSSRfErrorDetection__RF_BAND_L5 = 5
};

/// Constant 'JAMMING_STATE_UNKNOWN'.
/**
  * Enum values for jamming_state field
 */
enum
{
  microstrain_inertial_msgs__msg__GNSSRfErrorDetection__JAMMING_STATE_UNKNOWN = 0
};

/// Constant 'JAMMING_STATE_NONE'.
enum
{
  microstrain_inertial_msgs__msg__GNSSRfErrorDetection__JAMMING_STATE_NONE = 1
};

/// Constant 'JAMMING_STATE_PARTIAL'.
enum
{
  microstrain_inertial_msgs__msg__GNSSRfErrorDetection__JAMMING_STATE_PARTIAL = 2
};

/// Constant 'JAMMING_STATE_SIGNIFICANT'.
enum
{
  microstrain_inertial_msgs__msg__GNSSRfErrorDetection__JAMMING_STATE_SIGNIFICANT = 3
};

/// Constant 'SPOOFING_STATE_UNKNOWN'.
/**
  * Enum values for spoofing_state field
 */
enum
{
  microstrain_inertial_msgs__msg__GNSSRfErrorDetection__SPOOFING_STATE_UNKNOWN = 0
};

/// Constant 'SPOOFING_STATE_NONE'.
enum
{
  microstrain_inertial_msgs__msg__GNSSRfErrorDetection__SPOOFING_STATE_NONE = 1
};

/// Constant 'SPOOFING_STATE_PARTIAL'.
enum
{
  microstrain_inertial_msgs__msg__GNSSRfErrorDetection__SPOOFING_STATE_PARTIAL = 2
};

/// Constant 'SPOOFING_STATE_SIGNIFICANT'.
enum
{
  microstrain_inertial_msgs__msg__GNSSRfErrorDetection__SPOOFING_STATE_SIGNIFICANT = 3
};

/// Struct defined in msg/GNSSRfErrorDetection in the package microstrain_inertial_msgs.
typedef struct microstrain_inertial_msgs__msg__GNSSRfErrorDetection
{
  /// Must be one of the RF_BAND_* values
  uint8_t rf_band;
  /// Must be one of JAMMING_STATE_* values
  uint8_t jamming_state;
  /// Must be one of SPOOFING_STATE_* values
  uint8_t spoofing_state;
  uint16_t valid_flags;
} microstrain_inertial_msgs__msg__GNSSRfErrorDetection;

// Struct for a sequence of microstrain_inertial_msgs__msg__GNSSRfErrorDetection.
typedef struct microstrain_inertial_msgs__msg__GNSSRfErrorDetection__Sequence
{
  microstrain_inertial_msgs__msg__GNSSRfErrorDetection * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} microstrain_inertial_msgs__msg__GNSSRfErrorDetection__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_RF_ERROR_DETECTION__STRUCT_H_
