// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from microstrain_inertial_msgs:msg/GNSSSbasInfo.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_SBAS_INFO__BUILDER_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_SBAS_INFO__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "microstrain_inertial_msgs/msg/detail/gnss_sbas_info__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace microstrain_inertial_msgs
{

namespace msg
{

namespace builder
{

class Init_GNSSSbasInfo_valid_flags
{
public:
  explicit Init_GNSSSbasInfo_valid_flags(::microstrain_inertial_msgs::msg::GNSSSbasInfo & msg)
  : msg_(msg)
  {}
  ::microstrain_inertial_msgs::msg::GNSSSbasInfo valid_flags(::microstrain_inertial_msgs::msg::GNSSSbasInfo::_valid_flags_type arg)
  {
    msg_.valid_flags = std::move(arg);
    return std::move(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSSbasInfo msg_;
};

class Init_GNSSSbasInfo_status_test_mode
{
public:
  explicit Init_GNSSSbasInfo_status_test_mode(::microstrain_inertial_msgs::msg::GNSSSbasInfo & msg)
  : msg_(msg)
  {}
  Init_GNSSSbasInfo_valid_flags status_test_mode(::microstrain_inertial_msgs::msg::GNSSSbasInfo::_status_test_mode_type arg)
  {
    msg_.status_test_mode = std::move(arg);
    return Init_GNSSSbasInfo_valid_flags(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSSbasInfo msg_;
};

class Init_GNSSSbasInfo_status_integrity_available
{
public:
  explicit Init_GNSSSbasInfo_status_integrity_available(::microstrain_inertial_msgs::msg::GNSSSbasInfo & msg)
  : msg_(msg)
  {}
  Init_GNSSSbasInfo_status_test_mode status_integrity_available(::microstrain_inertial_msgs::msg::GNSSSbasInfo::_status_integrity_available_type arg)
  {
    msg_.status_integrity_available = std::move(arg);
    return Init_GNSSSbasInfo_status_test_mode(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSSbasInfo msg_;
};

class Init_GNSSSbasInfo_status_corrections_available
{
public:
  explicit Init_GNSSSbasInfo_status_corrections_available(::microstrain_inertial_msgs::msg::GNSSSbasInfo & msg)
  : msg_(msg)
  {}
  Init_GNSSSbasInfo_status_integrity_available status_corrections_available(::microstrain_inertial_msgs::msg::GNSSSbasInfo::_status_corrections_available_type arg)
  {
    msg_.status_corrections_available = std::move(arg);
    return Init_GNSSSbasInfo_status_integrity_available(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSSbasInfo msg_;
};

class Init_GNSSSbasInfo_status_range_available
{
public:
  explicit Init_GNSSSbasInfo_status_range_available(::microstrain_inertial_msgs::msg::GNSSSbasInfo & msg)
  : msg_(msg)
  {}
  Init_GNSSSbasInfo_status_corrections_available status_range_available(::microstrain_inertial_msgs::msg::GNSSSbasInfo::_status_range_available_type arg)
  {
    msg_.status_range_available = std::move(arg);
    return Init_GNSSSbasInfo_status_corrections_available(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSSbasInfo msg_;
};

class Init_GNSSSbasInfo_count
{
public:
  explicit Init_GNSSSbasInfo_count(::microstrain_inertial_msgs::msg::GNSSSbasInfo & msg)
  : msg_(msg)
  {}
  Init_GNSSSbasInfo_status_range_available count(::microstrain_inertial_msgs::msg::GNSSSbasInfo::_count_type arg)
  {
    msg_.count = std::move(arg);
    return Init_GNSSSbasInfo_status_range_available(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSSbasInfo msg_;
};

class Init_GNSSSbasInfo_sbas_id
{
public:
  explicit Init_GNSSSbasInfo_sbas_id(::microstrain_inertial_msgs::msg::GNSSSbasInfo & msg)
  : msg_(msg)
  {}
  Init_GNSSSbasInfo_count sbas_id(::microstrain_inertial_msgs::msg::GNSSSbasInfo::_sbas_id_type arg)
  {
    msg_.sbas_id = std::move(arg);
    return Init_GNSSSbasInfo_count(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSSbasInfo msg_;
};

class Init_GNSSSbasInfo_sbas_system
{
public:
  explicit Init_GNSSSbasInfo_sbas_system(::microstrain_inertial_msgs::msg::GNSSSbasInfo & msg)
  : msg_(msg)
  {}
  Init_GNSSSbasInfo_sbas_id sbas_system(::microstrain_inertial_msgs::msg::GNSSSbasInfo::_sbas_system_type arg)
  {
    msg_.sbas_system = std::move(arg);
    return Init_GNSSSbasInfo_sbas_id(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSSbasInfo msg_;
};

class Init_GNSSSbasInfo_gps_week_number
{
public:
  explicit Init_GNSSSbasInfo_gps_week_number(::microstrain_inertial_msgs::msg::GNSSSbasInfo & msg)
  : msg_(msg)
  {}
  Init_GNSSSbasInfo_sbas_system gps_week_number(::microstrain_inertial_msgs::msg::GNSSSbasInfo::_gps_week_number_type arg)
  {
    msg_.gps_week_number = std::move(arg);
    return Init_GNSSSbasInfo_sbas_system(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSSbasInfo msg_;
};

class Init_GNSSSbasInfo_gps_tow
{
public:
  Init_GNSSSbasInfo_gps_tow()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_GNSSSbasInfo_gps_week_number gps_tow(::microstrain_inertial_msgs::msg::GNSSSbasInfo::_gps_tow_type arg)
  {
    msg_.gps_tow = std::move(arg);
    return Init_GNSSSbasInfo_gps_week_number(msg_);
  }

private:
  ::microstrain_inertial_msgs::msg::GNSSSbasInfo msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::microstrain_inertial_msgs::msg::GNSSSbasInfo>()
{
  return microstrain_inertial_msgs::msg::builder::Init_GNSSSbasInfo_gps_tow();
}

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GNSS_SBAS_INFO__BUILDER_HPP_
