// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/GPSCorrelationTimestamp.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GPS_CORRELATION_TIMESTAMP__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GPS_CORRELATION_TIMESTAMP__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__GPSCorrelationTimestamp __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__GPSCorrelationTimestamp __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GPSCorrelationTimestamp_
{
  using Type = GPSCorrelationTimestamp_<ContainerAllocator>;

  explicit GPSCorrelationTimestamp_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0;
      this->gps_week_number = 0;
      this->timestamp_flags = 0;
    }
  }

  explicit GPSCorrelationTimestamp_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0;
      this->gps_week_number = 0;
      this->timestamp_flags = 0;
    }
  }

  // field types and members
  using _gps_tow_type =
    double;
  _gps_tow_type gps_tow;
  using _gps_week_number_type =
    uint16_t;
  _gps_week_number_type gps_week_number;
  using _timestamp_flags_type =
    uint16_t;
  _timestamp_flags_type timestamp_flags;

  // setters for named parameter idiom
  Type & set__gps_tow(
    const double & _arg)
  {
    this->gps_tow = _arg;
    return *this;
  }
  Type & set__gps_week_number(
    const uint16_t & _arg)
  {
    this->gps_week_number = _arg;
    return *this;
  }
  Type & set__timestamp_flags(
    const uint16_t & _arg)
  {
    this->timestamp_flags = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint16_t TIMESTAMP_FLAG_PPS_GOOD =
    1u;
  static constexpr uint16_t TIMESTAMP_FLAG_GPS_REFRESH =
    2u;
  static constexpr uint16_t TIMESTAMP_FLAG_GPS_INITALIZED =
    4u;

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::GPSCorrelationTimestamp_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::GPSCorrelationTimestamp_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestamp_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestamp_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::GPSCorrelationTimestamp_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestamp_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::GPSCorrelationTimestamp_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestamp_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestamp_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestamp_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__GPSCorrelationTimestamp
    std::shared_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestamp_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__GPSCorrelationTimestamp
    std::shared_ptr<microstrain_inertial_msgs::msg::GPSCorrelationTimestamp_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GPSCorrelationTimestamp_ & other) const
  {
    if (this->gps_tow != other.gps_tow) {
      return false;
    }
    if (this->gps_week_number != other.gps_week_number) {
      return false;
    }
    if (this->timestamp_flags != other.timestamp_flags) {
      return false;
    }
    return true;
  }
  bool operator!=(const GPSCorrelationTimestamp_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GPSCorrelationTimestamp_

// alias to use template instance with default allocator
using GPSCorrelationTimestamp =
  microstrain_inertial_msgs::msg::GPSCorrelationTimestamp_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t GPSCorrelationTimestamp_<ContainerAllocator>::TIMESTAMP_FLAG_PPS_GOOD;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t GPSCorrelationTimestamp_<ContainerAllocator>::TIMESTAMP_FLAG_GPS_REFRESH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t GPSCorrelationTimestamp_<ContainerAllocator>::TIMESTAMP_FLAG_GPS_INITALIZED;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__GPS_CORRELATION_TIMESTAMP__STRUCT_HPP_
