// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from microstrain_inertial_msgs:msg/ImuOverrangeStatus.idl
// generated code does not contain a copyright notice
#include "microstrain_inertial_msgs/msg/detail/imu_overrange_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
microstrain_inertial_msgs__msg__ImuOverrangeStatus__init(microstrain_inertial_msgs__msg__ImuOverrangeStatus * msg)
{
  if (!msg) {
    return false;
  }
  // status_accel_x
  // status_accel_y
  // status_accel_z
  // status_gyro_x
  // status_gyro_y
  // status_gyro_z
  // status_mag_x
  // status_mag_y
  // status_mag_z
  // status_press
  return true;
}

void
microstrain_inertial_msgs__msg__ImuOverrangeStatus__fini(microstrain_inertial_msgs__msg__ImuOverrangeStatus * msg)
{
  if (!msg) {
    return;
  }
  // status_accel_x
  // status_accel_y
  // status_accel_z
  // status_gyro_x
  // status_gyro_y
  // status_gyro_z
  // status_mag_x
  // status_mag_y
  // status_mag_z
  // status_press
}

bool
microstrain_inertial_msgs__msg__ImuOverrangeStatus__are_equal(const microstrain_inertial_msgs__msg__ImuOverrangeStatus * lhs, const microstrain_inertial_msgs__msg__ImuOverrangeStatus * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // status_accel_x
  if (lhs->status_accel_x != rhs->status_accel_x) {
    return false;
  }
  // status_accel_y
  if (lhs->status_accel_y != rhs->status_accel_y) {
    return false;
  }
  // status_accel_z
  if (lhs->status_accel_z != rhs->status_accel_z) {
    return false;
  }
  // status_gyro_x
  if (lhs->status_gyro_x != rhs->status_gyro_x) {
    return false;
  }
  // status_gyro_y
  if (lhs->status_gyro_y != rhs->status_gyro_y) {
    return false;
  }
  // status_gyro_z
  if (lhs->status_gyro_z != rhs->status_gyro_z) {
    return false;
  }
  // status_mag_x
  if (lhs->status_mag_x != rhs->status_mag_x) {
    return false;
  }
  // status_mag_y
  if (lhs->status_mag_y != rhs->status_mag_y) {
    return false;
  }
  // status_mag_z
  if (lhs->status_mag_z != rhs->status_mag_z) {
    return false;
  }
  // status_press
  if (lhs->status_press != rhs->status_press) {
    return false;
  }
  return true;
}

bool
microstrain_inertial_msgs__msg__ImuOverrangeStatus__copy(
  const microstrain_inertial_msgs__msg__ImuOverrangeStatus * input,
  microstrain_inertial_msgs__msg__ImuOverrangeStatus * output)
{
  if (!input || !output) {
    return false;
  }
  // status_accel_x
  output->status_accel_x = input->status_accel_x;
  // status_accel_y
  output->status_accel_y = input->status_accel_y;
  // status_accel_z
  output->status_accel_z = input->status_accel_z;
  // status_gyro_x
  output->status_gyro_x = input->status_gyro_x;
  // status_gyro_y
  output->status_gyro_y = input->status_gyro_y;
  // status_gyro_z
  output->status_gyro_z = input->status_gyro_z;
  // status_mag_x
  output->status_mag_x = input->status_mag_x;
  // status_mag_y
  output->status_mag_y = input->status_mag_y;
  // status_mag_z
  output->status_mag_z = input->status_mag_z;
  // status_press
  output->status_press = input->status_press;
  return true;
}

microstrain_inertial_msgs__msg__ImuOverrangeStatus *
microstrain_inertial_msgs__msg__ImuOverrangeStatus__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__ImuOverrangeStatus * msg = (microstrain_inertial_msgs__msg__ImuOverrangeStatus *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__ImuOverrangeStatus), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(microstrain_inertial_msgs__msg__ImuOverrangeStatus));
  bool success = microstrain_inertial_msgs__msg__ImuOverrangeStatus__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
microstrain_inertial_msgs__msg__ImuOverrangeStatus__destroy(microstrain_inertial_msgs__msg__ImuOverrangeStatus * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    microstrain_inertial_msgs__msg__ImuOverrangeStatus__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence__init(microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__ImuOverrangeStatus * data = NULL;

  if (size) {
    data = (microstrain_inertial_msgs__msg__ImuOverrangeStatus *)allocator.zero_allocate(size, sizeof(microstrain_inertial_msgs__msg__ImuOverrangeStatus), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = microstrain_inertial_msgs__msg__ImuOverrangeStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        microstrain_inertial_msgs__msg__ImuOverrangeStatus__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence__fini(microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      microstrain_inertial_msgs__msg__ImuOverrangeStatus__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence *
microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence * array = (microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence__destroy(microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence__are_equal(const microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence * lhs, const microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!microstrain_inertial_msgs__msg__ImuOverrangeStatus__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence__copy(
  const microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence * input,
  microstrain_inertial_msgs__msg__ImuOverrangeStatus__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(microstrain_inertial_msgs__msg__ImuOverrangeStatus);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    microstrain_inertial_msgs__msg__ImuOverrangeStatus * data =
      (microstrain_inertial_msgs__msg__ImuOverrangeStatus *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!microstrain_inertial_msgs__msg__ImuOverrangeStatus__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          microstrain_inertial_msgs__msg__ImuOverrangeStatus__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!microstrain_inertial_msgs__msg__ImuOverrangeStatus__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
