// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from microstrain_inertial_msgs:msg/InputSpeedMeasurement.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__INPUT_SPEED_MEASUREMENT__FUNCTIONS_H_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__INPUT_SPEED_MEASUREMENT__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "microstrain_inertial_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "microstrain_inertial_msgs/msg/detail/input_speed_measurement__struct.h"

/// Initialize msg/InputSpeedMeasurement message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * microstrain_inertial_msgs__msg__InputSpeedMeasurement
 * )) before or use
 * microstrain_inertial_msgs__msg__InputSpeedMeasurement__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_microstrain_inertial_msgs
bool
microstrain_inertial_msgs__msg__InputSpeedMeasurement__init(microstrain_inertial_msgs__msg__InputSpeedMeasurement * msg);

/// Finalize msg/InputSpeedMeasurement message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_microstrain_inertial_msgs
void
microstrain_inertial_msgs__msg__InputSpeedMeasurement__fini(microstrain_inertial_msgs__msg__InputSpeedMeasurement * msg);

/// Create msg/InputSpeedMeasurement message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * microstrain_inertial_msgs__msg__InputSpeedMeasurement__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_microstrain_inertial_msgs
microstrain_inertial_msgs__msg__InputSpeedMeasurement *
microstrain_inertial_msgs__msg__InputSpeedMeasurement__create();

/// Destroy msg/InputSpeedMeasurement message.
/**
 * It calls
 * microstrain_inertial_msgs__msg__InputSpeedMeasurement__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_microstrain_inertial_msgs
void
microstrain_inertial_msgs__msg__InputSpeedMeasurement__destroy(microstrain_inertial_msgs__msg__InputSpeedMeasurement * msg);

/// Check for msg/InputSpeedMeasurement message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_microstrain_inertial_msgs
bool
microstrain_inertial_msgs__msg__InputSpeedMeasurement__are_equal(const microstrain_inertial_msgs__msg__InputSpeedMeasurement * lhs, const microstrain_inertial_msgs__msg__InputSpeedMeasurement * rhs);

/// Copy a msg/InputSpeedMeasurement message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_microstrain_inertial_msgs
bool
microstrain_inertial_msgs__msg__InputSpeedMeasurement__copy(
  const microstrain_inertial_msgs__msg__InputSpeedMeasurement * input,
  microstrain_inertial_msgs__msg__InputSpeedMeasurement * output);

/// Initialize array of msg/InputSpeedMeasurement messages.
/**
 * It allocates the memory for the number of elements and calls
 * microstrain_inertial_msgs__msg__InputSpeedMeasurement__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_microstrain_inertial_msgs
bool
microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence__init(microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence * array, size_t size);

/// Finalize array of msg/InputSpeedMeasurement messages.
/**
 * It calls
 * microstrain_inertial_msgs__msg__InputSpeedMeasurement__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_microstrain_inertial_msgs
void
microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence__fini(microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence * array);

/// Create array of msg/InputSpeedMeasurement messages.
/**
 * It allocates the memory for the array and calls
 * microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_microstrain_inertial_msgs
microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence *
microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence__create(size_t size);

/// Destroy array of msg/InputSpeedMeasurement messages.
/**
 * It calls
 * microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_microstrain_inertial_msgs
void
microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence__destroy(microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence * array);

/// Check for msg/InputSpeedMeasurement message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_microstrain_inertial_msgs
bool
microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence__are_equal(const microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence * lhs, const microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence * rhs);

/// Copy an array of msg/InputSpeedMeasurement messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_microstrain_inertial_msgs
bool
microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence__copy(
  const microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence * input,
  microstrain_inertial_msgs__msg__InputSpeedMeasurement__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__INPUT_SPEED_MEASUREMENT__FUNCTIONS_H_
