// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/InputSpeedMeasurement.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__INPUT_SPEED_MEASUREMENT__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__INPUT_SPEED_MEASUREMENT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__InputSpeedMeasurement __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__InputSpeedMeasurement __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct InputSpeedMeasurement_
{
  using Type = InputSpeedMeasurement_<ContainerAllocator>;

  explicit InputSpeedMeasurement_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0f;
      this->speed = 0.0f;
      this->speed_uncertainty = 0.0f;
    }
  }

  explicit InputSpeedMeasurement_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gps_tow = 0.0f;
      this->speed = 0.0f;
      this->speed_uncertainty = 0.0f;
    }
  }

  // field types and members
  using _gps_tow_type =
    float;
  _gps_tow_type gps_tow;
  using _speed_type =
    float;
  _speed_type speed;
  using _speed_uncertainty_type =
    float;
  _speed_uncertainty_type speed_uncertainty;

  // setters for named parameter idiom
  Type & set__gps_tow(
    const float & _arg)
  {
    this->gps_tow = _arg;
    return *this;
  }
  Type & set__speed(
    const float & _arg)
  {
    this->speed = _arg;
    return *this;
  }
  Type & set__speed_uncertainty(
    const float & _arg)
  {
    this->speed_uncertainty = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::InputSpeedMeasurement_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::InputSpeedMeasurement_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::InputSpeedMeasurement_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::InputSpeedMeasurement_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::InputSpeedMeasurement_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::InputSpeedMeasurement_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::InputSpeedMeasurement_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::InputSpeedMeasurement_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::InputSpeedMeasurement_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::InputSpeedMeasurement_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__InputSpeedMeasurement
    std::shared_ptr<microstrain_inertial_msgs::msg::InputSpeedMeasurement_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__InputSpeedMeasurement
    std::shared_ptr<microstrain_inertial_msgs::msg::InputSpeedMeasurement_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const InputSpeedMeasurement_ & other) const
  {
    if (this->gps_tow != other.gps_tow) {
      return false;
    }
    if (this->speed != other.speed) {
      return false;
    }
    if (this->speed_uncertainty != other.speed_uncertainty) {
      return false;
    }
    return true;
  }
  bool operator!=(const InputSpeedMeasurement_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct InputSpeedMeasurement_

// alias to use template instance with default allocator
using InputSpeedMeasurement =
  microstrain_inertial_msgs::msg::InputSpeedMeasurement_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__INPUT_SPEED_MEASUREMENT__STRUCT_HPP_
