// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:srv/GetComplementaryFilter.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_COMPLEMENTARY_FILTER__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_COMPLEMENTARY_FILTER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__GetComplementaryFilter_Request __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__GetComplementaryFilter_Request __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetComplementaryFilter_Request_
{
  using Type = GetComplementaryFilter_Request_<ContainerAllocator>;

  explicit GetComplementaryFilter_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit GetComplementaryFilter_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::GetComplementaryFilter_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::GetComplementaryFilter_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::GetComplementaryFilter_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::GetComplementaryFilter_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__GetComplementaryFilter_Request
    std::shared_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__GetComplementaryFilter_Request
    std::shared_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetComplementaryFilter_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetComplementaryFilter_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetComplementaryFilter_Request_

// alias to use template instance with default allocator
using GetComplementaryFilter_Request =
  microstrain_inertial_msgs::srv::GetComplementaryFilter_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace microstrain_inertial_msgs


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__GetComplementaryFilter_Response __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__GetComplementaryFilter_Response __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetComplementaryFilter_Response_
{
  using Type = GetComplementaryFilter_Response_<ContainerAllocator>;

  explicit GetComplementaryFilter_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->north_comp_enable = 0;
      this->up_comp_enable = 0;
      this->north_comp_time_const = 0.0f;
      this->up_comp_time_const = 0.0f;
      this->success = false;
    }
  }

  explicit GetComplementaryFilter_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->north_comp_enable = 0;
      this->up_comp_enable = 0;
      this->north_comp_time_const = 0.0f;
      this->up_comp_time_const = 0.0f;
      this->success = false;
    }
  }

  // field types and members
  using _north_comp_enable_type =
    int8_t;
  _north_comp_enable_type north_comp_enable;
  using _up_comp_enable_type =
    int8_t;
  _up_comp_enable_type up_comp_enable;
  using _north_comp_time_const_type =
    float;
  _north_comp_time_const_type north_comp_time_const;
  using _up_comp_time_const_type =
    float;
  _up_comp_time_const_type up_comp_time_const;
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__north_comp_enable(
    const int8_t & _arg)
  {
    this->north_comp_enable = _arg;
    return *this;
  }
  Type & set__up_comp_enable(
    const int8_t & _arg)
  {
    this->up_comp_enable = _arg;
    return *this;
  }
  Type & set__north_comp_time_const(
    const float & _arg)
  {
    this->north_comp_time_const = _arg;
    return *this;
  }
  Type & set__up_comp_time_const(
    const float & _arg)
  {
    this->up_comp_time_const = _arg;
    return *this;
  }
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::GetComplementaryFilter_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::GetComplementaryFilter_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::GetComplementaryFilter_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::GetComplementaryFilter_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__GetComplementaryFilter_Response
    std::shared_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__GetComplementaryFilter_Response
    std::shared_ptr<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetComplementaryFilter_Response_ & other) const
  {
    if (this->north_comp_enable != other.north_comp_enable) {
      return false;
    }
    if (this->up_comp_enable != other.up_comp_enable) {
      return false;
    }
    if (this->north_comp_time_const != other.north_comp_time_const) {
      return false;
    }
    if (this->up_comp_time_const != other.up_comp_time_const) {
      return false;
    }
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetComplementaryFilter_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetComplementaryFilter_Response_

// alias to use template instance with default allocator
using GetComplementaryFilter_Response =
  microstrain_inertial_msgs::srv::GetComplementaryFilter_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace microstrain_inertial_msgs
{

namespace srv
{

struct GetComplementaryFilter
{
  using Request = microstrain_inertial_msgs::srv::GetComplementaryFilter_Request;
  using Response = microstrain_inertial_msgs::srv::GetComplementaryFilter_Response;
};

}  // namespace srv

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_COMPLEMENTARY_FILTER__STRUCT_HPP_
