// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from microstrain_inertial_msgs:srv/SetRelativePositionReference.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_RELATIVE_POSITION_REFERENCE__STRUCT_H_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_RELATIVE_POSITION_REFERENCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SOURCE_AUTO'.
/**
  * RTK base station required
 */
enum
{
  microstrain_inertial_msgs__srv__SetRelativePositionReference_Request__SOURCE_AUTO = 0
};

/// Constant 'SOURCE_MANUAL'.
enum
{
  microstrain_inertial_msgs__srv__SetRelativePositionReference_Request__SOURCE_MANUAL = 1
};

/// Constant 'FRAME_ECEF'.
enum
{
  microstrain_inertial_msgs__srv__SetRelativePositionReference_Request__FRAME_ECEF = 1
};

/// Constant 'FRAME_LLH'.
enum
{
  microstrain_inertial_msgs__srv__SetRelativePositionReference_Request__FRAME_LLH = 2
};

// Include directives for member types
// Member 'position'
#include "geometry_msgs/msg/detail/vector3__struct.h"

/// Struct defined in srv/SetRelativePositionReference in the package microstrain_inertial_msgs.
typedef struct microstrain_inertial_msgs__srv__SetRelativePositionReference_Request
{
  uint8_t source;
  uint8_t frame;
  geometry_msgs__msg__Vector3 position;
} microstrain_inertial_msgs__srv__SetRelativePositionReference_Request;

// Struct for a sequence of microstrain_inertial_msgs__srv__SetRelativePositionReference_Request.
typedef struct microstrain_inertial_msgs__srv__SetRelativePositionReference_Request__Sequence
{
  microstrain_inertial_msgs__srv__SetRelativePositionReference_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} microstrain_inertial_msgs__srv__SetRelativePositionReference_Request__Sequence;


// Constants defined in the message

/// Struct defined in srv/SetRelativePositionReference in the package microstrain_inertial_msgs.
typedef struct microstrain_inertial_msgs__srv__SetRelativePositionReference_Response
{
  bool success;
} microstrain_inertial_msgs__srv__SetRelativePositionReference_Response;

// Struct for a sequence of microstrain_inertial_msgs__srv__SetRelativePositionReference_Response.
typedef struct microstrain_inertial_msgs__srv__SetRelativePositionReference_Response__Sequence
{
  microstrain_inertial_msgs__srv__SetRelativePositionReference_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} microstrain_inertial_msgs__srv__SetRelativePositionReference_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_RELATIVE_POSITION_REFERENCE__STRUCT_H_
