// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:srv/SetTareOrientation.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_TARE_ORIENTATION__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_TARE_ORIENTATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "microstrain_inertial_msgs/srv/detail/set_tare_orientation__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace microstrain_inertial_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetTareOrientation_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: axis
  {
    out << "axis: ";
    rosidl_generator_traits::value_to_yaml(msg.axis, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetTareOrientation_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: axis
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "axis: ";
    rosidl_generator_traits::value_to_yaml(msg.axis, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetTareOrientation_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::srv::SetTareOrientation_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::srv::SetTareOrientation_Request & msg)
{
  return microstrain_inertial_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::SetTareOrientation_Request>()
{
  return "microstrain_inertial_msgs::srv::SetTareOrientation_Request";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::SetTareOrientation_Request>()
{
  return "microstrain_inertial_msgs/srv/SetTareOrientation_Request";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::SetTareOrientation_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::SetTareOrientation_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::SetTareOrientation_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace microstrain_inertial_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetTareOrientation_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetTareOrientation_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetTareOrientation_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::srv::SetTareOrientation_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::srv::SetTareOrientation_Response & msg)
{
  return microstrain_inertial_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::SetTareOrientation_Response>()
{
  return "microstrain_inertial_msgs::srv::SetTareOrientation_Response";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::SetTareOrientation_Response>()
{
  return "microstrain_inertial_msgs/srv/SetTareOrientation_Response";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::SetTareOrientation_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::SetTareOrientation_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::SetTareOrientation_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::SetTareOrientation>()
{
  return "microstrain_inertial_msgs::srv::SetTareOrientation";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::SetTareOrientation>()
{
  return "microstrain_inertial_msgs/srv/SetTareOrientation";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::SetTareOrientation>
  : std::integral_constant<
    bool,
    has_fixed_size<microstrain_inertial_msgs::srv::SetTareOrientation_Request>::value &&
    has_fixed_size<microstrain_inertial_msgs::srv::SetTareOrientation_Response>::value
  >
{
};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::SetTareOrientation>
  : std::integral_constant<
    bool,
    has_bounded_size<microstrain_inertial_msgs::srv::SetTareOrientation_Request>::value &&
    has_bounded_size<microstrain_inertial_msgs::srv::SetTareOrientation_Response>::value
  >
{
};

template<>
struct is_service<microstrain_inertial_msgs::srv::SetTareOrientation>
  : std::true_type
{
};

template<>
struct is_service_request<microstrain_inertial_msgs::srv::SetTareOrientation_Request>
  : std::true_type
{
};

template<>
struct is_service_response<microstrain_inertial_msgs::srv::SetTareOrientation_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_TARE_ORIENTATION__TRAITS_HPP_
